;Ŀ
; Z80 ۳  Joltima !!!!  ۳ jman  ۳
;
;
;       Joltima is an RPG for the Z80.  The follwing version is designed to
;       run on a TI-83 graphing calculator using Ashell83.
;
;       The game is similar to Dragon Warrior for the NES.
;       To play:
;       Press 2nd to go to your menu and execute commands.
;       Press Alpha to cancel a menu or skip your turn in battle.
;       Press Clear to quit the game at any time.
;       Press the arrows to move your charater or the cursor.
;
;       Objective:
;       Defeat the wizard in the castle.  To get to the castle,
;       you must first get all 8 shard items from around the map.
;
;Ŀ
; Z80 ۳  Joltima !!!!  ۳ jman  ۳
;
;
.NOLIST

#define equ .equ
#define EQU .equ
#define end .end

#include "ti83asm.inc"
#include "tokens.inc"

.LIST

kDown   .equ 254          
kLeft   .equ 253
kRight  .equ 251
kUp     .equ 247
kMode   .equ 191
kClear  .equ 191

	.org    9327h

	nop                     ;these 2 lines identify the program
	jr      prog_start      ;as AShell-compatable
	.dw     $0000         ;Version of table
	.dw     Description   ;Points to the program description
	.dw     Icon          ;Points to an 8x8 icon
	.dw     $0000         ;For future use ( *Libraries*? :)

Description:
	.db "JOLTIMA V1.31 by Infiniti",0
Icon:
	.db %11111111    ;this example icon is a box
	.db %10000001    ;icons are not displayed by AShell
	.db %10000001    ;but the next version of Aurora will support
	.db %10000001    ;this format for icons
	.db %10000001
	.db %10000001
	.db %10000001
	.db %11111111
prog_start:
	jr     START
;Ŀ
; Z80 ۳    EQUATES     ۳ jman  ۳
;
ITEMAMOUNT      .equ    28
JEFFSTR .equ    50
UP      .equ    0
DOWN    .equ    1
LEFT    .equ    2
RIGHT   .equ    3
NONE    .equ    4

OVER    .equ    0
TOWN    .equ    1
CAVE    .equ    2

P1      .equ    0
P2      .equ    16
P3      .equ    32
P4      .equ    48

CX      .equ    0
CY      .equ    1
OX      .equ    2
OY      .equ    3
TYPE    .equ    4
MOVING  .equ    5
DIR     .equ    6
COUNT   .equ    7
REQ     .equ    8
SQX     .equ    9
SQY     .equ    10
DO      .equ    11
MSG     .equ    12

; ---------------------------------------------------------
; data can be found at the very bottom, if you must see it.
; ---------------------------------------------------------

;Ŀ
; Z80 ۳      CODE      ۳ jman  ۳
;

START:
	call    RINDOFF         ; Turn off runindicator
	call    BUFCLR          ; Clear the graphbuf
	call    BUFCOPY         ; Copy the graphbuf to the LCD
	ld      (spbackup), sp  ; remember this!

	; load the map
	;ld      hl, scratch
	;call    findprog
	;or a
	;jp      z,EXIT
	ld      de, zjram

	ld      (map), de
	ld      hl, (map)
	ld      bc, 5376
	add     hl, bc
	ld      (stamps), hl
	ld      bc, 128
	add     hl, bc
	ld      (stamp_ok), hl
	ld      bc, 117
	add     hl, bc
	ld      (pad), hl
	ld      bc, 260
	add     hl, bc
	
	;ld      hl, zjdata
	;call    findprog
	;or a
	;jp      z,EXIT
	ld      de, zjdata

;------------------------------------------------------------------------
; START OF FILE SIZES - FILE SIZES MUST MATCH FILES ON DISK B4 ASSEMBLING
;------------------------------------------------------------------------
	ld      (title_gra), de
	ld      hl, (title_gra)
	ld      bc, 528
	add     hl, bc
	ld      (cmap), hl
	;ld      bc, 1368
	ld      bc, 1335
	add     hl, bc
	ld      (townp), hl
	ld      bc, 275
	add     hl, bc
	ld      (townp + 2), hl
	ld      bc, 292
	add     hl, bc
	ld      (townp + 4), hl
	ld      bc, 250
	add     hl, bc
	ld      (townp + 6), hl
	ld      bc, 303
	add     hl, bc
	ld      (townp + 8), hl
	ld      bc, 166
	add     hl, bc
	ld      (stampbase), hl
	ld      bc, 768
	add     hl, bc
	ld      (chars), hl
	ld      bc, 128
	add     hl, bc
	ld      (enemy_gra), hl
	ld      bc, 80
	add     hl, bc
	ld      (font), hl
	ld      bc, 512

	add     hl, bc
	ld      (str), hl
	ld      bc, 2231        ; strings from JEXT;update after every change
	
	add     hl, bc
	ld      (towndata), hl
	ld      bc, 155

	add     hl, bc
	ld      (townxy), hl
	ld      bc, 98
	add     hl, bc
	ld      (searchdata), hl
	ld      bc, ITEMAMOUNT*5; 28 treasure chests * 5 bytes
	add     hl, bc
	ld      (enemydata), hl
	ld      bc, 40
	add     hl, bc
	ld      (form_data), hl
	ld      bc, 224
	add     hl, bc
	ld      (shopdata), hl
	ld      bc, 40
	add     hl, bc
	ld      (itemdata), hl
	ld      bc, 72
	add     hl, bc
	ld      (view), hl
	ld      bc, 520
	add     hl, bc
	
	ld      (cavep), hl
	ld      bc, 648 ; 9 caves
	add     hl, bc
	ld      (bat1_gra), hl
	ld      bc, 192
	add     hl, bc
;------------------------------------------------------------------------
; END OF FILE SIZES
;------------------------------------------------------------------------

	; set-up the string table
	ld      hl, (str)
	ld      a, (hl)
	inc     hl
	ld      (strtable), hl
	ld      c, a
	ld      b, 0
	add     hl, bc  ; 2xNUM ;-)
	add     hl, bc
	ld      (str), hl

begingame:
	call    getch
	call    blank
	ld      de, 8e29h
	ld      hl, (title_gra)
	ld      bc, 528
	ldir

	ld      a, 8
	ld      e, 44
	ld      c, 80
	ld      b, 18
	call    window
	ld      c, 54
	ld      a, 17
	ld      e, 48
	call    stext
	ld      a, 12
	ld      e, 48
	ld      c, 2
	call    menupick
	cp      0
	jp      z, begingame
	ld      a, (index)
	cp      0
	jp      z, begin_con
	cp      1
	jp      z, begin_new

begin_new:
	ld      hl, newgame
	ld      ix, ch
	ld      b, 4
	call    setup_players

	ld      de, partydata
	ld      hl, newgame + 20
	ld      bc, 129
	ldir
	call    name_party

	ld      b, 4
	ld      c, 0
reset_exp:
	push    bc
	ld      a, c
	call    getexp4next     ; set up experience points for level2
	pop     bc
	inc     c
	djnz    reset_exp

	ld      a, 60
	call    bigtext

	call    blank
	ld      a, 62
	call    talkbox
	jp      begin_done

begin_con:
	ld      hl, savedgame
	ld      ix, ch
	ld      b, 4
	call    setup_players

	ld      de, partydata
	ld      hl, savedgame + 20
	ld      bc, 129
	ldir
	jp      begin_done

begin_done:

	; load the map
	ld      a, 4
	ld      (chnum), a
	ld      (nparty), a
	call    setup_map

	xor a
	ld      (mademove), a
MAIN:
	; Render screen
	ld      a, (ch+CX)
	sub     5
	ld      (ssx), a
	
	ld      a, (ch+CY)
	sub     3
	ld      (ssy), a
	
	ld      a, (ch+OX)
	sub     4
	call    c,dec_ssx
	and     7
	ld      (sox), a
	
	ld      a, (ch+OY)
	sub     4
	call    c,dec_ssy
	and     7
	ld      (soy), a

	call    BUFCLR
	call    set_view
	call    draw_map
	
	ld      a, (chnum)
	ld      b, a
	ld      de, 0
draw_ch_loop:
	push    bc
	push    de

	call    draw_player
	
	; request party to do nothing while we're at it
	;ld      hl, ch+REQ
	;add     hl, de
	;ld      a, NONE
	;ld      (hl), a
	
	pop     de
	pop     bc

	ld      a, e
	add     a, 16
	ld      e, a
	
	djnz    draw_ch_loop
	
	call    BUFCOPY         ; Copy the graphbuf to the LCD
;------------------------------------------

; INPUT
;------------------------------------------
	; request party to do nothing
	ld      a, NONE
	ld      (ch+REQ+P1), a
	ld      (ch+REQ+P2), a
	ld      (ch+REQ+P3), a
	ld      (ch+REQ+P4), a
	
	; check for random battle
	ld      a, (ch+MOVING)
	cp      1
	jr      z, check_input
	ld      a, (mademove)
	cp      1
	jr      nz, no_battle
	ld      a, (maptype)
	cp      TOWN
	jr      z, no_battle
	ld      a, 16
	call    rand
	and     15
	cp      1
	call    z, battle
no_battle:
	xor a
	ld      (mademove), a
check_input:

	ld      a,0ffh          ; reset keyport

	out     (1),a
	ld      a,0feh          ; pick column the arrows are in
	out     (1),a
	in      a,(1)
	cp      kDown           ; check for down
	jp      z,KEY_DOWN
	cp      kLeft           ; check for left
	jp      z,KEY_LEFT
	cp      kRight          ; check for right
	jp      z,KEY_RIGHT
	cp      kUp             ; check for up
	jr      z,KEY_UP

	ld      a, (ch+MOVING)
	cp      1
	jp      z, AFTER_INPUT

	;call    GET_KEY
	;cp      G_YEDIT
	call    getch
	cp      11h
	call    z, pause
	;cp      G_2ND
	cp      21h
	call    z, menu
	cp      45h
	call    z, exit

	jp      AFTER_INPUT

KEY_UP:
	ld      a, (ch+MOVING)
	cp      1
	jp      z, AFTER_INPUT
	
	; check for boundary
	ld      a, (ch+SQY)
	dec     a
	ld      b, a
	ld      a, (ch+SQX)
	call    getmap2
	ld      a, (hl)
	
	push    af
	and     15
	cp      10
	call    z, upon10
	pop     af

	and     64
	cp      64
	jp      z, AFTER_INPUT
	
	ld      a, UP
	call    hitd
	cp      1
	jp      nz, AFTER_INPUT

	ld      a, UP
	ld      (ch+REQ), a
	jp      AFTER_INPUT

KEY_RIGHT:
	ld      a, (ch+MOVING)
	cp      1
	jp      z, AFTER_INPUT
	
	; check for boundary
	ld      a, (ch+SQY)
	ld      b, a
	ld      a, (ch+SQX)
	inc     a
	call    getmap2
	ld      a, (hl)
	
	push    af
	and     15
	cp      10
	call    z, rton10
	pop     af
	
	and     64
	cp      64
	jp      z, AFTER_INPUT
	
	ld      a, RIGHT
	call    hitd
	cp      1
	jp      nz, AFTER_INPUT
	
	ld      a, RIGHT
	ld      (ch+REQ), a
	jp      AFTER_INPUT
KEY_LEFT:
	ld      a, (ch+MOVING)
	cp      1
	jp      z, AFTER_INPUT
	
	; check for boundary
	ld      a, (ch+SQY)
	ld      b, a
	ld      a, (ch+SQX)
	dec     a
	call    getmap2
	ld      a, (hl)
	
	push    af
	and     15
	cp      10
	call    z, lfon10
	pop     af

	and     64
	cp      64
	jr      z, AFTER_INPUT
	
	ld      a, LEFT
	call    hitd
	cp      1
	jr      nz, AFTER_INPUT
	
	ld      a, LEFT
	ld      (ch+REQ), a
	jr      AFTER_INPUT
KEY_DOWN:
	ld      a, (ch+MOVING)
	cp      1
	jp      z, AFTER_INPUT
	
	; check for boundary
	ld      a, (ch+SQY)
	inc     a
	ld      b, a
	ld      a, (ch+SQX)
	call    getmap2
	ld      a, (hl)
	
	push    af
	and     15
	cp      10
	call    z, dnon10
	pop     af

	and     64
	cp      64
	jr      z, AFTER_INPUT
	
	ld      a, DOWN
	call    hitd
	cp      1
	jr      nz, AFTER_INPUT
	
	ld      a, DOWN
	ld      (ch+REQ), a

AFTER_INPUT:

	; move party members
	ld      a, (ch+REQ)
	cp      NONE
	jr      z,no_party_move
	ld      (lastmovs+3), a
	ld      a, (lastmovs+2)
	ld      (ch+REQ+P2), a
	ld      a, (lastmovs+1)
	ld      (ch+REQ+P3), a
	ld      a, (lastmovs)
	ld      (ch+REQ+P4), a

	ld      a, (lastmovs+1)
	ld      (lastmovs), a
	ld      a, (lastmovs+2)
	ld      (lastmovs+1), a
	ld      a, (lastmovs+3)
	ld      (lastmovs+2), a
	
no_party_move:
	
	ld      bc, P1
	call    char_req
	ld      bc, P2
	call    char_req
	ld      bc, P3
	call    char_req
	ld      bc, P4
	call    char_req

	ld      bc, P1
	call    char_move
	ld      bc, P2
	call    char_move
	ld      bc, P3
	call    char_move
	ld      bc, P4
	call    char_move

	ld      a, (animtimer)
	inc     a
	ld      (animtimer), a
	cp      5
	jr      nz, after_anims
	xor a
	ld      (animtimer), a

	ld      a,(frame)
	or      a
	jr      z,SECOND_FRAME
FIRST_FRAME:
	xor a
	ld      (frame),a
	ld      bc, 128
	ld      de, (stamps)
	ld      hl, (stampmem)
	ldir
	jr      after_anims
SECOND_FRAME:
	ld      a,1
	ld      (frame),a
	ld      bc, 128
	ld      de, (stamps)
	ld      hl, (stampmem)
	add     hl, bc
	ldir

after_anims:

	; check to see if you're standing on a special thing (town, etc)
	ld      a, (ch+P1+MOVING)
	cp      1
	jp      z, no_check_4special
	ld      a, (maptype)
	cp      CAVE
	jp      nz, not_final
	ld      a, (ch+P1+SQY)
	ld      b, a
	ld      a, (ch+P1+SQX)
	call    getmap2
	ld      a, (hl)
	and     15
	cp      3
	jp      nz, not_final
	ld      a, 64
	call    talkbox
	ld      a, 27
	call    battle_spec
not_final:
	
	ld      a, (maptype)
	cp      OVER
	jr      z, check_over

check_town:
	ld      a, (ch+P1+SQY)
	ld      b, a
	ld      a, (ch+P1+SQX)
	call    getmap2
	ld      a, (hl)
	and     15
	cp      15
	jp      z, leavetown
	jp      no_check_4special
	
check_over:
	ld      a, (ch+P1+SQY)
	ld      b, a
	ld      a, (ch+P1+SQX)
	call    getmap2
	ld      a, (hl)
	cp      15
	jp      z, rideboat

	ld      b, 14   ; 5 towns + 9 caves
	ld      hl, (townxy)
cp_townxy:
	push    hl
	push    bc
	ld      a, (ch+P1+SQX)
	ld      b, a
	ld      a, (hl)
	cp      b
	jr      nz, cp_next_town
	ld      a, (ch+P1+SQY)
	ld      b, a
	inc     hl
	ld      a, (hl)
	cp      b
	jr      nz, cp_next_town

	; enter the town
	inc     hl
	ld      a, (hl)
	ld      (x), a
	inc     hl
	ld      a, (hl)
	ld      (y), a
	ld      bc, 3
	add     hl, bc
	ld      a, (hl)
	ld      (mapnum), a
	pop     bc
	pop     hl
	jr      load_town

cp_next_town:
	pop     bc
	pop     hl
	ld      de, 7
	add     hl, de
	djnz    cp_townxy

	jr      cp_town_done

load_town:
	ld      a, (x)
	ld      (ch+P1+CX), a
	ld      a, (y)
	ld      (ch+P1+CY), a
	
	ld      a, (x)
	ld      (ch+P2+CX), a
	ld      a, (y)
	ld      (ch+P2+CY), a
	
	ld      a, (x)
	ld      (ch+P3+CX), a
	ld      a, (y)
	ld      (ch+P3+CY), a
	
	ld      a, (x)
	ld      (ch+P4+CX), a
	ld      a, (y)
	ld      (ch+P4+CY), a
	
	ld      a, (mapnum)
	cp      5
	jr      nc, cp_maptype2
cp_maptype1:
	ld      a, TOWN
	jr      cp_maptype_done
cp_maptype2:
	ld      a, CAVE
cp_maptype_done:
	ld      (maptype), a
	
	call    clear_follow
	call    blank
	call    setup_map

cp_town_done:
	jp      no_check_4special

rideboat:
	ld      a, (boat)
	cp      0
	jp      z, ride2island
	cp      1
	jp      z, ride2main

ride2island:
	ld      a, 1
	ld      (boat), a
	ld      a, 27
	ld      c, a
	ld      a, 51
	ld      b, a
	jp      ride_done
ride2main:
	ld      a, 0
	ld      (boat), a
	ld      a, 30
	ld      c, a
	ld      a, 48
	ld      b, a
	jp      ride_done
ride_done:
	call    setparty
	call    clear_follow
	call    setup_map
	jp      no_check_4special

leavetown:
	ld      a, OVER
	ld      (maptype), a
	xor     a
	ld      (mapnum), a

	ld      a, (etownx)
	ld      c, a
	ld      a, (etowny)
	ld      b, a
	call    setparty

	call    clear_follow
	call    setup_map

no_check_4special:

	ld      a, (ch+MOVING)
	cp      1
	jr      nz, no_movement
	ld      a, 1
	ld      (mademove), a
no_movement:
	jp      MAIN

DELAY:
	push    af
	push    bc
	ld      bc, 03500h
DELAYLOOP:
	dec     bc
	ld      a,b
	or      c
	jr      nz,DELAYLOOP
	pop     bc
	pop     af
	ret

;   Exit the program   
EXIT:
	ld      sp, (spbackup)  ; haha! it didn't matter how deep we were
	;call    res_data        ; restore the integrity of the file, JASM
	call    CLRTSHD         ; Clear textshadow
	call    GOHOME          ; Leave graphscreen and go to homescreen
	call    BUFCLR          ; Clear the graphbuf
	call    READKEY         ; Catch the clear press
	call    HOMEUP          ; Place cursor at home
	ret                     ; Exit program

;Ŀ
; Z80 ۳   PROCEDURES   ۳ movax ۳
;

; DRWSPR 
;Ŀ
; Draw 8x8 sprite  a=x, e=y, hl=sprite address                              
;
DRWSPR:

	push    ix              ; ix gets trashed
	push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

	ld      hl,0            ; Do y*12
	ld      d,0
	add     hl,de
	add     hl,de
	add     hl,de
	add     hl,hl
	add     hl,hl

	ld      d,0             ; Do x/8
	ld      e,a
	srl     e
	srl     e
	srl     e
	add     hl,de

	ld      de,8e29h
	add     hl,de           ; Add address to graphbuf

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	or a               ; Is this sprite aligned to 8*n,y?
	jr      z,ALIGN


;   Non aligned sprite blit starts here   

	pop     ix              ; ix->sprite
	ld      d,a             ; d=how many bits to shift each line

	ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

	ld      c,0             ; Shift loop
	push    de
SHLOP:  srl     b
	rr      c
	dec     d
	jr      nz,SHLOP
	pop     de

	ld      a,b             ; Write line to graphbuf
	or      (hl)
	ld      (hl),a
	inc     hl
	ld      a,c
	or      (hl)
	ld      (hl),a

	ld      bc,11           ; Calculate next line address
	add     hl,bc
	inc     ix              ; Inc spritepointer

	dec     e
	jr      nz,LILOP        ; Next line

	jr      DONE1


;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
	pop     de              ; de->sprite
	ld      b,8
ALOP1:  ld      a,(de)
	or      (hl)            ; xor=erase/blit
	ld      (hl),a
	inc     de
	push    bc
	ld      bc,12
	add     hl,bc
	pop     bc
	djnz    ALOP1

DONE1:
	pop     ix              ; restore ix
	ret
; DRWSPR 


; CLRSPR 
;Ŀ
; Clear 8x8 sprite  a=x, e=y, hl=sprite address                             
;
CLRSPR:
	push    ix
	push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

	ld      hl,0            ; Do y*12
	ld      d,0
	add     hl,de
	add     hl,de
	add     hl,de
	add     hl,hl
	add     hl,hl

	ld      d,0             ; Do x/8
	ld      e,a
	srl     e
	srl     e
	srl     e
	add     hl,de

	ld      de,8e29h
	add     hl,de           ; Add address to graphbuf

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	or a               ; Is this sprite aligned to 8*n,y?
	jr      z,ALIGN2


;   Non aligned sprite erase starts here   

	pop     ix              ; ix->sprite
	ld      d,a             ; d=how many bits to shift each line

	ld      e,8             ; Line loop
LILOP2: ld      b,(ix+0)        ; Get sprite data

	ld      c,0             ; Shift loop
	push    de
SHLOP2: srl     b
	rr      c
	dec     d
	jr      nz,SHLOP2
	pop     de

	ld      a,b             ; Write line to graphbuf
	cpl
	and     (hl)
	ld      (hl),a
	inc     hl
	ld      a,c
	cpl
	and     (hl)
	ld      (hl),a

	ld      bc,11           ; Calculate next line address
	add     hl,bc
	inc     ix              ; Inc spritepointer

	dec     e
	jr      nz,LILOP2       ; Next line

	jr      DONE5


;   Aligned sprite erase starts here   

ALIGN2:                         ; Erase an aligned sprite in graphbuf
	pop     de              ; de->sprite
	ld      b,8
ALOP2:  ld      a,(de)
	cpl
	and     (hl)
	ld      (hl),a
	inc     de
	push    bc
	ld      bc,12
	add     hl,bc
	pop     bc
	djnz    ALOP2

DONE5:
	pop     ix
	ret
; CLRSPR 

;MUL:
;        push    bc
;        push    de
;        ld      b, h
;        ld      e, l
;        ld      hl, 0
;        ld      d, 0
;mul_loop:
;        add     hl, de
;        djnz    mul_loop
;        pop     de
;        pop     bc
;        ret
;DIV:
;        push    bc
;        push    de
;div_loop:
;        ld      a, l
;        sub     b
;        jp      s,div_done
;        jp      div
;div_done:

dec_ssx:
	push    af
	ld      a, (ssx)
	dec     a
	ld      (ssx), a
	pop     af
	ret
dec_ssy:
	push    af
	ld      a, (ssy)
	dec     a
	ld      (ssy), a
	pop     af
	ret

_putx           .db     0, 0
_puty           .db     0, 0
_putmap         .db     0, 0
_putstamps      .db     0, 0
_put_ok         .db     0, 0

_map_x  .db     0
_map_y  .db     0
_mapcounter     .db 0, 0
_okcounter      .db 0, 0
_deep   .db     0, 0
_tab_x  .db     0
_tab_y  .db     0
_tab_ex .db     0
_tab_ey .db     0
_atx    .db     0
_aty    .db     0
_blackstamp     .db     255,255,255,255,255,255,255,255

_stamp_offsets  .db     0, 8, 16, 24, 32, 40, 48, 56,
		.db     64, 72, 80, 88, 96, 104, 112, 120
_n      .db     0
_n2     .db     0, 0

draw_map:
	
	ld      hl, 0
	ld      de, 0
	ld      e, 84
	ld      a, (ssy)
	ld      b, a
	or a
	jr      z, no_y_offset
draw_offset_loop:
	add     hl, de
	djnz    draw_offset_loop
no_y_offset:
	ld      bc, 0
	ld      a, (ssx)
	ld      c, a
	add     hl, bc
	
	ld      (_putx), hl
	
	ld      a, (sox)
	ld      b, a
	ld      a, 8
	sub     b
	ld      (_tab_x), a
	
	ld      a, (soy)
	ld      b, a
	ld      a, 8
	sub     b
	ld      (_tab_ey), a
	ld      a, (soy)
	ld      (_tab_y), a

	ld      bc, (map)
	ld      (_putmap), bc
	ld      bc, (stamps)
	ld      (_putstamps), bc
	ld      bc, (stamp_ok)
	ld      (_put_ok), bc
	
	
	ld      a, (_tab_x)
	or a
	jr      z,draw_tab_test1

	ld      a, (_tab_y)
	or a
	jp      z,offx
	jp      offxy
draw_tab_test1:
	ld      a, (_tab_y)
	or a
	jp      nz,offy

normal:
; ----------------------------- Normal ------------------------

	push    de
	push    bc
	push    hl
	push    af

	ld      bc, (_putx)
	ld      (_mapcounter), bc

	ld      bc, 0
	ld      (_deep), bc
	ld      (_okcounter), bc
	
	ld      c, 0
	ld      b, 8
normal_ys_loop:
	push    bc
	ld      c, 0
	ld      b, 12
normal_xs_loop:
	push    bc

	ld      hl, (_put_ok)
	ld      bc, (_okcounter)
	add     hl, bc
	ld      a, (hl)
	ld      hl, _blackstamp
	or a
	jr      z, normal_putbad

	ld      hl, (_putmap)
	ld      bc, (_mapcounter)
	add     hl, bc
	ld      a, (hl)
	and     15

	ld      hl, _stamp_offsets
	ld      b, 0
	ld      c, a
	add     hl, bc
	ld      a, (hl)

	ld      hl, (_putstamps)
	ld      b, 0
	ld      c, a
	add     hl, bc

normal_putbad:
	
	; ---draw the stamp here---
	push    hl
	ld      hl, 8e29h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      b, 8
normal_ydraw_loop:
	push    bc
	ld      a, (de)
	or      (hl)
	ld      (hl), a
	ld      bc, 12
	add     hl, bc
	inc     de
	pop     bc
	djnz    normal_ydraw_loop
	; ---done drawing stamp ---

	ld      bc, (_deep)
	inc     bc
	ld      (_deep), bc

	ld      bc, (_mapcounter)
	inc     bc
	ld      (_mapcounter), bc
	
	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc
	
	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,normal_xs_loop
normal_xs_loop_done:
	ld      hl, (_deep)
	ld      bc, 84
	add     hl, bc
	ld      (_deep), hl

	ld      hl, (_mapcounter)
	ld      bc, 72
	add     hl, bc
	ld      (_mapcounter), hl
	
	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc

	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,normal_ys_loop
normal_ys_loop_done:
	pop     af
	pop     hl
	pop     bc
	pop     de

	jp      draw_map_end
;for(n2 = 0; n2 < 1200; ++n2);
;goto    draw_map_end;

offx:
; ----------------------------- OFF by X ----------------------
	push    de
	push    bc
	push    hl
	push    af

	ld      bc, (_putx)
	ld      (_mapcounter), bc

	ld      bc, 0
	ld      (_deep), bc
	ld      (_okcounter), bc
	
	ld      c, 0
	ld      b, 8
offx_ys_loop:
	push    bc
	ld      c, 0
	ld      b, 13
offx_xs_loop:
	push    bc
	ld      a, b
	ld      (_atx), a

	ld      hl, (_put_ok)
	ld      bc, (_okcounter)
	add     hl, bc
	ld      a, (hl)
	ld      hl, _blackstamp
	or a
	jr      z, offx_putbad
	
	ld      hl, (_putmap)
	ld      bc, (_mapcounter)
	add     hl, bc
	ld      a, (hl)
	and     15

	ld      hl, _stamp_offsets
	ld      b, 0
	ld      c, a
	add     hl, bc
	ld      a, (hl)

	ld      hl, (_putstamps)
	ld      b, 0
	ld      c, a
	add     hl, bc
	
offx_putbad:

	; ---draw the stamp here---
	push    hl
	ld      hl, 8e28h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      b, 8
offx_ydraw_loop:
	push    bc

	ld      c, 0
	ld      a, (de)
	ld      b, a
	push    de
	ld      a, (_tab_x)
	ld      d, a
offx_shlop:
	srl     b
	rr      c
	dec     d
	jr      nz,offx_shlop
	pop     de

	ld      a, (_atx)       ; Check to see if on leftborder
	cp      13
	jr      z,offx_on_lb
	
	ld      a,b             ; Write line to graphbuf
	or      (hl)
	ld      (hl),a
offx_on_lb:
	inc     hl
	
	ld      a, (_atx)       ; Check to see if on rightborder
	cp      1
	jr      z,offx_on_rb

	ld      a,c
	or      (hl)
	ld      (hl),a
offx_on_rb:

	ld      bc, 11
	add     hl, bc
	inc     de
	pop     bc
	djnz    offx_ydraw_loop
	; ---done drawing stamp ---

	ld      bc, (_deep)
	inc     bc
	ld      (_deep), bc

	ld      bc, (_mapcounter)
	inc     bc
	ld      (_mapcounter), bc

	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc
	
	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offx_xs_loop
offx_xs_loop_done:
	ld      hl, (_deep)
	ld      bc, 83
	add     hl, bc
	ld      (_deep), hl

	ld      hl, (_mapcounter)
	ld      bc, 71
	add     hl, bc
	ld      (_mapcounter), hl

	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offx_ys_loop
offx_ys_loop_done:
	pop     af
	pop     hl
	pop     bc
	pop     de
	
	jp      draw_map_end

offy:
;----------------------------- OFF by Y ----------------------
	push    de
	push    bc
	push    hl
	push    af

	ld      bc, (_putx)
	ld      (_mapcounter), bc

	ld      bc, 0
	ld      (_deep), bc
	ld      (_okcounter), bc
	
	ld      c, 0
	ld      b, 9
offy_ys_loop:
	push    bc
	ld      a, b
	ld      (_aty), a

	ld      c, 0
	ld      b, 12
offy_xs_loop:
	push    bc

	ld      hl, (_put_ok)
	ld      bc, (_okcounter)
	add     hl, bc
	ld      a, (hl)
	ld      hl, _blackstamp
	or a
	jr      z, offy_putbad
	
	ld      hl, (_putmap)
	ld      bc, (_mapcounter)
	add     hl, bc
	ld      a, (hl)
	and     15

	ld      hl, _stamp_offsets
	ld      b, 0
	ld      c, a
	add     hl, bc
	ld      a, (hl)

	ld      hl, (_putstamps)
	ld      b, 0
	ld      c, a
	add     hl, bc

offy_putbad:

	; ---draw the stamp here---
	ld      a, (_aty)       ; Check to see if on topborder
	cp      9
	jr      z,offy_on_tb
	
	ld      a, (_aty)       ; Check to see if on bottomborder
	cp      1
	jr      z,offy_on_bb
	
	push    hl
	ld      hl, 8e29h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	ld      c, 0
	ld      b, 8
	jr      offy_ydraw_loop

offy_on_tb:
	ld      a, (_tab_y)
	ld      c, a
	ld      b, 0
	add     hl, bc
	
	push    hl
	ld      hl, 8e29h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      a, (_tab_ey)
	ld      b, a
	jr      offy_ydraw_loop
offy_on_bb:
	push    hl
	ld      hl, 8e29h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      a, (_tab_y)
	ld      b, a
	jr      offy_ydraw_loop

offy_ydraw_loop:
	push    bc
	ld      a, (de)
	or      (hl)
	ld      (hl), a
	ld      bc, 12
	add     hl, bc
	inc     de
	pop     bc
	djnz    offy_ydraw_loop
	; ---done drawing stamp ---

	ld      bc, (_deep)
	inc     bc
	ld      (_deep), bc

	ld      bc, (_mapcounter)
	inc     bc
	ld      (_mapcounter), bc

	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc

	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offy_xs_loop
offy_xs_loop_done:
	ld      a, (_aty)       ; Check to see if on topborder
	cp      9
	jr      z,offy_on_tb_deep
	
	ld      hl, (_deep)
	ld      bc, 84
	add     hl, bc
	ld      (_deep), hl
	jp      offy_after_deepfix

offy_on_tb_deep:
	ld      c, 0
	ld      a, (_tab_ey)
	ld      b, a
	xor a
	dec     b
offy_multloop:
	add     a, 12
	djnz    offy_multloop
	ld      c, a
	ld      b, 0
	
	ld      hl, (_deep)
	add     hl, bc
	ld      (_deep), hl
offy_after_deepfix:
	ld      hl, (_mapcounter)
	ld      bc, 72
	add     hl, bc
	ld      (_mapcounter), hl

	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc
	
	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offy_ys_loop
offy_ys_loop_done:
	pop     af
	pop     hl
	pop     bc
	pop     de
	
	jp      draw_map_end

offxy:
;--------------------- OFF by X AND Y (what a concept) -------
	push    de
	push    bc
	push    hl
	push    af

	ld      bc, (_putx)
	ld      (_mapcounter), bc

	ld      bc, 0
	ld      (_deep), bc
	ld      (_okcounter), bc
	
	ld      c, 0
	ld      b, 9
offxy_ys_loop:
	push    bc
	ld      a, b
	ld      (_aty), a

	ld      c, 0
	ld      b, 13
offxy_xs_loop:
	push    bc
	ld      a, b
	ld      (_atx), a

	ld      hl, (_put_ok)
	ld      bc, (_okcounter)
	add     hl, bc
	ld      a, (hl)
	ld      hl, _blackstamp
	or a    
	jr      z, offxy_putbad

	ld      hl, (_putmap)
	ld      bc, (_mapcounter)
	add     hl, bc
	ld      a, (hl)
	and     15

	ld      hl, _stamp_offsets
	ld      b, 0
	ld      c, a
	add     hl, bc
	ld      a, (hl)

	ld      hl, (_putstamps)
	ld      b, 0
	ld      c, a
	add     hl, bc

offxy_putbad:
	
	; ---draw the stamp here---
	ld      a, (_aty)       ; Check to see if on topborder
	cp      9
	jr      z,offxy_on_tb
	
	ld      a, (_aty)       ; Check to see if on bottomborder
	cp      1
	jr      z,offxy_on_bb
	
	push    hl
	ld      hl, 8e28h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	ld      c, 0
	ld      b, 8
	jr      offxy_ydraw_loop

offxy_on_tb:
	ld      a, (_tab_y)
	ld      c, a
	ld      b, 0
	add     hl, bc
	
	push    hl
	ld      hl, 8e28h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      a, (_tab_ey)
	ld      b, a
	jr      offxy_ydraw_loop
offxy_on_bb:
	push    hl
	ld      hl, 8e28h
	ld      bc, (_deep)
	add     hl, bc
	pop     de
	
	ld      c, 0
	ld      a, (_tab_y)
	ld      b, a
	jr      offxy_ydraw_loop

offxy_ydraw_loop:
	push    bc
	;--------------
	ld      c, 0
	ld      a, (de)
	ld      b, a
	push    de
	ld      a, (_tab_x)
	ld      d, a
offxy_shlop:
	srl     b
	rr      c
	dec     d
	jr      nz,offxy_shlop
	pop     de

	ld      a, (_atx)       ; Check to see if on leftborder
	cp      13
	jr      z,offxy_on_lb
	
	ld      a,b             ; Write line to graphbuf
	or      (hl)
	ld      (hl),a
offxy_on_lb:
	inc     hl
	
	ld      a, (_atx)       ; Check to see if on rightborder
	cp      1
	jr      z,offxy_on_rb

	ld      a,c
	or      (hl)
	ld      (hl),a
offxy_on_rb:

	ld      bc, 11
	add     hl, bc
	inc     de
	pop     bc
	djnz    offxy_ydraw_loop
	; ---done drawing stamp ---

	ld      bc, (_deep)
	inc     bc
	ld      (_deep), bc

	ld      bc, (_mapcounter)
	inc     bc
	ld      (_mapcounter), bc
	
	ld      bc, (_okcounter)
	inc     bc
	ld      (_okcounter), bc
	
	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offxy_xs_loop
offxy_xs_loop_done:
	ld      a, (_aty)       ; Check to see if on topborder
	cp      9
	jr      z,offxy_on_tb_deep
	
	ld      hl, (_deep)
	ld      bc, 83
	add     hl, bc
	ld      (_deep), hl
	jr      offxy_after_deepfix

offxy_on_tb_deep:
	ld      c, 0
	ld      a, (_tab_ey)
	ld      b, a
	xor a
	dec     b
offxy_multloop:
	add     a, 12
	djnz    offxy_multloop
	dec     a
	ld      c, a
	ld      b, 0
	
	ld      hl, (_deep)
	add     hl, bc
	ld      (_deep), hl

offxy_after_deepfix:
	ld      hl, (_mapcounter)
	ld      bc, 71
	add     hl, bc
	ld      (_mapcounter), hl

	pop     bc              ; restore bc
	dec     b
	ld      a, b
	or a
	jp      nz,offxy_ys_loop
offxy_ys_loop_done:
	pop     af
	pop     hl
	pop     bc
	pop     de

draw_map_end:
	ret

; FINDPROG-  entry: HL=PROGNAME, ret: DE=PROGADDR
;findprog:
;        push    hl
;        call    _ZEROOOP1
;        pop     hl
;        ld      a, 5
;        ld      (OP1), a
;        ld      de, OP1+1
;        ld      bc, 8
;        ldir
;        call    _CHKFINDSYM
;        jr      c, finderror
;        inc     de
;        inc     de
;        ld      a, 1
;        ret
;finderror:
;        xor a
;find_done:
;        ret

frame   .db     0

; CHAR_REQ - setup movement for BC player.  BC = P1,P2,P3 || P4
char_req:
	ld      hl, ch+REQ
	add     hl, bc
	ld      a, (hl)
	
	cp      UP
	jr      z, req_up
	cp      DOWN
	jr      z, req_down
	cp      LEFT
	jp      z, req_left
	cp      RIGHT
	jp      z, req_right
	jp      after_req
req_up:
	ld      hl, ch+SQY
	add     hl, bc
	ld      a, (hl)
	dec     a
	ld      (hl), a

	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),1
	; gonna move 4 steps (2 pixels each)
	ld      hl, ch+COUNT
	add     hl, bc
	ld      (hl),3
	
	ld      hl, ch+OY
	add     hl, bc
	ld      (hl),8
	
	ld      hl, ch+CY
	add     hl, bc
	ld      a, (hl)
	dec     a
	ld      (hl), a

	ld      hl, ch+DIR
	add     hl, bc
	ld      (hl),UP
	jp      after_req

req_right:
	ld      hl, ch+SQX
	add     hl, bc
	ld      a, (hl)
	inc     a
	ld      (hl), a
	
	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),1
	; gonna move 4 steps (2 pixels each)
	ld      hl, ch+COUNT
	add     hl, bc
	ld      (hl),3
	
	ld      hl, ch+DIR
	add     hl, bc
	ld      (hl),RIGHT
	jp      after_req

req_left:
	ld      hl, ch+SQX
	add     hl, bc
	ld      a, (hl)
	dec     a
	ld      (hl), a

	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),1
	; gonna move 4 steps (2 pixels each)
	ld      hl, ch+COUNT
	add     hl, bc
	ld      (hl),3
	
	ld      hl, ch+OX
	add     hl, bc
	ld      (hl),8
	
	ld      hl, ch+CX
	add     hl, bc
	ld      a, (hl)
	dec     a
	ld      (hl), a

	ld      hl, ch+DIR
	add     hl, bc
	ld      (hl),LEFT
	jr      after_req

req_down:
	ld      hl, ch+SQY
	add     hl, bc
	ld      a, (hl)
	inc     a
	ld      (hl), a

	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),1
	; gonna move 4 steps (2 pixels each)
	ld      hl, ch+COUNT
	add     hl, bc
	ld      (hl),3
	
	ld      hl, ch+DIR
	add     hl, bc
	ld      (hl),DOWN
after_req:
	ret

; CHAR_MOVE - move BC player.  BC = P1,P2,P3 || P4
char_move:
	ld      hl, ch+MOVING
	add     hl, bc
	ld      a, (hl)
	
	cp      1
	jp      nz, AFTER_MOVE
	ld      hl, ch+DIR
	add     hl, bc
	ld      a, (hl)
	
	cp      DOWN
	jp      z, move_down
	cp      RIGHT
	jr      z, move_right
	cp      UP
	jp      z, move_up
	cp      LEFT
	jr      z, move_left
	jp      AFTER_MOVE

move_right:
	ld      hl, ch+COUNT
	add     hl, bc
	ld      a, (hl)

	or a
	jr      nz, still_move_right
	ld      hl, ch+MOVING
	add     hl, bc
	xor a
	ld      (hl),0
	ld      hl, ch+OX
	add     hl, bc
	ld      (hl), a
	ld      hl, ch+CX
	add     hl, bc
	ld      a, (hl)
	inc     a
	ld      (hl), a
	jp      AFTER_MOVE
still_move_right:
	dec     a
	ld      (hl), a
	ld      hl, ch+OX
	add     hl, bc
	ld      a, (hl)
	add     a, 2
	ld      (hl), a
	jp      AFTER_MOVE

move_left:
	ld      hl, ch+COUNT
	add     hl, bc
	ld      a, (hl)
	or a
	jr      nz, still_move_left
	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),0
	ld      hl, ch+OX
	add     hl, bc
	ld      (hl), a
	jp      AFTER_MOVE
still_move_left:
	dec     a
	ld      (hl), a
	ld      hl, ch+OX
	add     hl, bc
	ld      a, (hl)
	sub     2
	ld      (hl), a
	jp      AFTER_MOVE

move_down:
	ld      hl, ch+COUNT
	add     hl, bc
	ld      a, (hl)

	or a
	jr      nz, still_move_down
	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),0
	ld      hl, ch+OY
	add     hl, bc
	ld      (hl), a
	ld      hl, ch+CY
	add     hl, bc
	ld      a, (hl)
	inc     a
	ld      (hl), a
	jr      AFTER_MOVE
still_move_down:
	dec     a
	ld      (hl), a
	ld      hl, ch+OY
	add     hl, bc
	ld      a, (hl)
	add     a, 2
	ld      (hl), a
	jr      AFTER_MOVE

move_up:
	ld      hl, ch+COUNT
	add     hl, bc
	ld      a, (hl)
	or a
	jr      nz, still_move_up
	ld      hl, ch+MOVING
	add     hl, bc
	ld      (hl),0
	ld      hl, ch+OY
	add     hl, bc
	ld      (hl), a
	jr      AFTER_MOVE
still_move_up:
	dec     a
	ld      (hl), a
	ld      hl, ch+OY
	add     hl, bc
	ld      a, (hl)
	sub     2
	ld      (hl), a

AFTER_MOVE:
	ret

; DRAW_PLAYER - draws player DE.  DE = P1,P2,P3 || P4
draw_px .db     0, 0
draw_py .db     0, 0
scrx    .db     0, 0
scry    .db     0, 0
tmp_p   .db     0, 0
draw_player:
	ld      a, (ssx)
	ld      b, a
	ld      a, (sox)
	ld      c, a
	call    convert
	ld      (scrx), bc

	ld      a, (ssy)
	ld      b, a
	ld      a, (soy)
	ld      c, a
	call    convert
	ld      (scry), bc

	ld      hl, ch+CX
	add     hl, de
	ld      a, (hl)
	ld      b, a
	ld      hl, ch+OX
	add     hl, de
	ld      a, (hl)
	ld      c, a
	call    convert
	ld      (draw_px), bc

	ld      hl, ch+CY
	add     hl, de
	ld      a, (hl)
	ld      b, a
	ld      hl, ch+OY
	add     hl, de
	ld      a, (hl)
	ld      c, a
	call    convert
	ld      (draw_py), bc

	; test x range
	ld      bc, 88
	ld      hl, (scrx)
	add     hl, bc          ; hl = scrx + (96-8)
	ld      bc, (draw_px)   ; bc = draw_px
	sbc     hl, bc          ; is bc bigger than hl? (to far right?)
	jp      c, char_badrange

	ld      hl, (draw_px)   ; hl = draw_px
	ld      bc, (scrx)      ; bc = scrx
	sbc     hl, bc          ; is bc bigger than hl? (to far left?)
	jp      c, char_badrange
	ld      a, l
	ld      (x), a          ; store difference as xposition

	; test y range
	ld      bc, 56
	ld      hl, (scry)
	add     hl, bc          ; hl = scry + (64-8)
	ld      bc, (draw_py)   ; bc = draw_py
	sbc     hl, bc          ; is bc bigger than hl? (to far below?)
	jp      c, char_badrange

	ld      hl, (draw_py)   ; hl = draw_py
	ld      bc, (scry)      ; bc = scry
	sbc     hl, bc          ; is bc bigger than hl? (to far up?)
	jp      c, char_badrange
	ld      a, l
	ld      (y), a          ; store difference as yposition

	; draw the character now
	ld      bc, 0
	ld      hl, ch+TYPE
	add     hl, de
	ld      a, (hl)
	ld      c, a
	ld      hl, char_offsets
	add     hl, bc
	ld      c, (hl)
	ld      hl, (chars)
	add     hl, bc

	ld      a,(frame)
	cp      1
	jr      z,DISP_SF
DISP_FF:
	jr      DISP_SPRITE
DISP_SF:
	ld      bc, 8
	add     hl, bc
DISP_SPRITE:
	ld      a,(y)
	ld      e,a             ; Load the y-coordinate in e
	ld      a,(x)           ; Load the x-coordinate in a
	call    DRWSPR          ; Draw the stamp in the graphbuf
char_badrange:
	ret
	
; CONVERT - turn b stamp and c offset into 16bit pixel address BC
convert:
	push    hl
	push    de
	ld      d, 0
	ld      e, b
	ld      b, 8
	ld      hl, 0
convert_loop:
	add     hl, de
	djnz    convert_loop
	ld      e, c
	add     hl, de
	push    hl
	pop     bc
	
	pop     de
	pop     hl
	
	ret

; GETMAP - put pointer to map's B (ycoord) and C (xcoord) into HL
getmap2:
	ld      c, a
getmap:
	push    de
	push    bc
	ld      hl, (map)
	ld      d, 0
	ld      e, b
	ld      b, 84
get_map_loop:
	add     hl, de
	djnz    get_map_loop
	pop     bc
	ld      b, 0
	add     hl, bc
	pop     de

	ret

; GETXY - put A character's SQY value into B and SQX value into C
getxy:
	push    af
	push    de
	push    hl
	
	ld      d, 0
	ld      e, a
	ld      b, 16
	ld      hl, ch
getx_aloop:
	add     hl, de
	djnz    getx_aloop
	push    hl
	ld      de, SQY
	add     hl, de
	ld      a, (hl)
	ld      b, a
	pop     hl
	ld      de, SQX
	add     hl, de
	ld      a, (hl)
	ld      c, a

	pop     hl
	pop     de
	pop     af
	
	ret

; SET_VIEW - like, sets the view (uses ch+P1+[SQX,SQY] as ref)
; I should be commended for writing this routine in assembly =)
set_view:
	; zero out the view window
	ld      b, 117
	ld      hl, (stamp_ok)
view_zero_stamp_ok:
	ld      (hl), 0
	inc     hl
	djnz    view_zero_stamp_ok

	; set xfix/yfix  (makes the screen do the right thing... don't ask)
	
	; C code:
	;       x = ch[0].sqx;
	;       y = ch[0].sqy;
	;
	;       xfix = yfix = 0;
	;
	;       if(ch[0].mode == LEFT && ch[0].count >= 2)
	;               xfix = -1;
	;       else if(ch[0].mode == RIGHT && ch[0].count > 2)
	;               xfix = 1;
	;       if(ch[0].mode == UP && ch[0].count >= 2)
	;               yfix = -1;
	;       else if(ch[0].mode == DOWN && ch[0].count > 2)
	;               yfix = 1;
	;
	;       x2 = xfix+6;
	;       y2 = yfix+4;
	;       ok[((y2)*13+x2)] = 1;
	xor a
	ld      (xfix), a
	ld      (yfix), a
	
	ld      a, (ch+P1+MOVING)
	cp      1
	jp      nz, view_no_fixes

	; check left/right
view_check_left:
	ld      a, (ch+P1+DIR)
	cp      LEFT
	jr      z, view_fix_left
view_check_right:
	ld      a, (ch+P1+DIR)
	cp      RIGHT
	jr      z, view_fix_right
	jr      view_after_xfix

view_fix_left:
	ld      a, (ch+P1+COUNT)
	sub     1
	jr      c, view_check_right
	ld      a, -1
	ld      (xfix), a
	jr      view_after_xfix
view_fix_right:
	ld      a, (ch+P1+COUNT)
	sub     2
	jr      c, view_after_xfix
	ld      a, 1
	ld      (xfix), a
view_after_xfix:

	; check up/down
view_check_up:
	ld      a, (ch+P1+DIR)
	cp      UP
	jr      z, view_fix_up
view_check_down:
	ld      a, (ch+P1+DIR)
	cp      DOWN
	jr      z, view_fix_down
	jr      view_after_yfix

view_fix_up:
	ld      a, (ch+P1+COUNT)
	sub     1
	jr      c, view_check_down
	ld      a, -1
	ld      (yfix), a
	jr      view_after_yfix
view_fix_down:
	ld      a, (ch+P1+COUNT)
	sub     2
	jr      c, view_after_yfix
	ld      a, 1
	ld      (yfix), a
view_after_yfix:

view_no_fixes:
	
	; make center 3x3 viewable
	ld      hl, (stamp_ok)
	ld      bc, 44
	add     hl, bc
	ld      (hl), 1
	inc     hl
	ld      (hl), 1
	inc     hl
	ld      (hl), 1
	
	ld      hl, (stamp_ok)
	ld      bc, 57
	add     hl, bc
	ld      (hl), 1
	inc     hl
	ld      (hl), 1
	inc     hl
	ld      (hl), 1
	
	ld      hl, (stamp_ok)
	ld      bc, 70
	add     hl, bc
	ld      (hl), 1
	inc     hl
	ld      (hl), 1
	inc     hl
	ld      (hl), 1

	ld      hl, ch+P1+SQY
	ld      a, (hl)
	ld      d, 0
	ld      e, a
	ld      hl, (map)
	ld      b, 84
view_get_center:
	add     hl, de
	djnz    view_get_center
	ld      de, ch+P1+SQX
	ld      a, (de)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (pp1), hl

	ld      de, 0

; big-bad wannabe for(n=0;n<40;++n) to do all 40 lines
set_view_loop2:
	push    de
	ld      b, 0
	ld      a, e
	sub     20
	jr      c, view_noadd260
view_add260:
	ld      c, a
	ld      hl, view_offsets
	
	add     hl, bc
	ld      a, (hl)
	ld      hl, (view)
	ld      de, 260
	add     hl, de
	jr      view_done_adding
view_noadd260:
	ld      a, e
	ld      c, a
	ld      hl, view_offsets
	
	add     hl, bc
	ld      a, (hl)
	ld      hl, (view)
view_done_adding:
	
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (pp2), hl
	ld      hl, (pp1)       ; restore the center of map (on screen)
	
	; use the fixes on (x) [stamp_ok offset]
	ld      a, 58
	ld      b, a
	ld      a, (xfix)
	add     a, b
	
	ld      b, a
	ld      a, (yfix)
	cp      1
	jr      z, view_add_yfix
	cp      -1
	jr      z, view_sub_yfix
	or a
	jr      z, view_zero_yfix
	jr      view_done_yfix
view_sub_yfix:
	ld      a, b
	sub     13
	jr      view_done_yfix
view_add_yfix:
	ld      a, b
	add     a, 13
	jr      view_done_yfix
view_zero_yfix:
	ld      a, b
view_done_yfix:
	ld      (x), a

; big-bad loop for scanning each line
set_view_loop1:
	push    hl
	ld      hl, (pp2)       ; get viewtable and bump hl
	ld      a, (hl)
	inc     hl
	ld      (pp2), hl
	pop     hl
	cp      15              ; quit on 15 (0xf)
	jp      z, set_view_loop1_done
	
	cp      1                       ; add 1 line of map if say so
	jr      z, view_forward_x
	cp      -1                      ; subtract 1 line of map if say so
	jr      z, view_back_x
	jr view_no_move_x       ; don't move anywhere on a zero
view_forward_x:
	ld      a, (x)
	inc     a
	ld      (x), a
	inc     hl
	jr      view_no_move_x
view_back_x:
	ld      a, (x)
	dec     a
	ld      (x), a
	dec     hl
view_no_move_x:
	
	push    hl
	ld      hl, (pp2)       ; get viewtable and bump hl
	ld      a, (hl)
	inc     hl
	ld      (pp2), hl
	pop     hl
	
	cp      15              ; quit on 15 (0xf)
	jp      z, set_view_loop1_done
	cp      1                       ; add 1 line of map if say so
	jr      z, view_forward_y
	cp      -1                      ; subtract 1 line of map if say so
	jr      z, view_back_y
	jr      view_no_move_y       ; don't move anywhere on a zero
view_forward_y:
	ld      a, (x)
	add     a, 13
	ld      (x), a
	ld      bc, 84
	add     hl, bc
	jr      view_no_move_y
view_back_y:
	ld      a, (x)
	sub     13
	ld      (x), a
	ld      bc, 84
	sbc     hl, bc
view_no_move_y:
	
	; make sure (x) is not larger than the stamp_ok array
	ld      a, (x)
	sub     117
	jr      nc, set_view_loop1_done
	
	; now that we're in the correct spot, check the map
	push    hl
	ld      hl, (stamp_ok)
	ld      a, (x)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (hl),1
	pop     hl

	ld      a, (hl)
	and     128
	cp      128
	jp      nz,set_view_loop1

set_view_loop1_done:

	pop     de
	inc     de
	ld      a, e
	cp      40
	jp      nz, set_view_loop2

	ret
	
uncomwid        .db     0
uncomx          .db     0
uncomdif        .db     0
uncomtmp        .db     0, 0
uncomsize       .db     0, 0
; UNCOM - uncompresses a map. HL = cmap, BC = size, A = Width (A <= 84)
; mainmap --> A=84
; townmap --> A=38
uncom:
	ld      (uncomsize), bc
	ld      (uncomwid), a
	ld      b, a
	ld      a, 84
	sub     b
	ld      (uncomdif), a
	xor a
	ld      (uncomx), a
	; uncompress the map (main)
	ld      de, (map)
	ld      bc, 0
uncom_mainmap:
	push    bc
	ld      a, (hl)
	ld      b, a
	and     15
	srl     b
	srl     b
	srl     b
	srl     b
unroll_loop:
	ld      (de), a
	inc     de
	
	push    af
	push    bc
	push    hl
	ld      a, (uncomwid)
	ld      b, a
	ld      a, (uncomx)
	inc     a
	ld      (uncomx), a
	cp      b
	jr      nz, uncom_no_wchange
	xor a
	ld      (uncomx), a
	
	ld      (uncomtmp), de
	ld      hl, (uncomtmp)
	ld      a, (uncomdif)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (uncomtmp), hl
	ld      de, (uncomtmp)
uncom_no_wchange:
	pop     hl
	pop     bc
	pop     af

	djnz    unroll_loop
	inc     hl
	pop     bc
	inc     bc

	ld      a, (uncomsize+1)
	cp      b
	jr nz,uncom_mainmap
uncom_check1:
	ld      a, (uncomsize)
	cp      c
	jr nz,uncom_mainmap
uncom_done:
	ret

; SETUP_MAP - sets up the map. (maptype) = OVER,T1-T5. set (ch+PX+CX,CY) also
cur_town        .db     0, 0
setup_map:        
	call blank
	; figure out which type of map is to be loaded
	ld      a, (maptype)
	cp      OVER
	jr      z, setup_overworld
	cp      TOWN
	jr      z, setup_town
	cp      CAVE
	jp      z, setup_cave

setup_overworld:
	ld      a, (nparty)
	ld      (chnum), a

	ld      bc, 537h        ; size
	ld      hl, (cmap)      ; pointer to compressed data
	ld      a, 84           ; width of map
	call    uncom
	ld      hl, (stampbase)
	ld      bc, 0
	add     hl, bc
	ld      (stampmem), hl

	ld      a, (boat)
	cp      0
	jp      z, boat_dock
	cp      1
	jp      z, boat_island
boat_dock:
	ld      c, 30
	ld      b, 49
	call    getmap
	ld      a, 15
	ld      (hl), a
	jp      setup_done_uncom
boat_island:
	ld      c, 27
	ld      b, 50
	call    getmap
	ld      a, 15
	ld      (hl), a
	jp      setup_done_uncom

setup_town:
	ld      a, (mapnum)
	ld      e, a
	ld      d, 0
	ld      b, 31   ;97
	ld      hl, (towndata)
towndatlp:
	add     hl, de
	djnz    towndatlp
	ld      (cur_town), hl
	ld      a, (hl)
	ld      b, a
	inc     hl

	ld      ix, ch+64
	call    setup_players
	ld      a, (nparty)
	add     a, c
	ld      (chnum), a

	;ld      a, (hl)
	;ld      de, 16
	;ld      hl, 0
	;ld      b, a

	;ld      a, (nparty)
;setup_npc_loop:
	;add     hl, de
	;inc     a
	;djnz    setup_npc_loop
	;ld      (chnum), a
	; set the byte amount into bc
	;push    hl
	;pop     bc

	; set the destination into de
	;ld      hl, ch
	;ld      de, 64
	;add     hl, de
	;push    hl
	;pop     de
	
	;ld      hl, (cur_town)
	;inc     hl
	;ldir                    ; copy npc #1 into slot 5...

	; setup the location on exit
	call    setup_xyexit        

	; go and uncompress the townmap
	ld      a, (mapnum)
	or a
	jr      z, set_town1
	cp      1
	jr      z, set_town2
	cp      2
	jr      z, set_town3
	cp      3
	jr      z, set_town4
	cp      4
	jr      z, set_town5
	jp      setup_done_uncom

set_town1:        
	ld      bc, 276         ; size
	ld      hl, (townp)     ; pointer to compressed data
	ld      a, 38           ; width of map
	jr      town_setup_done
set_town2:
	ld      a, (shards)
	cp      8
	call    z, remove_guy

	ld      bc, 291         ; size
	ld      hl, (townp+2)   ; pointer to compressed data
	ld      a, 38           ; width of map
	jr      town_setup_done
set_town3:
	ld      bc, 250         ; size
	ld      hl, (townp+4)   ; pointer to compressed data
	ld      a, 38           ; width of map
	jr      town_setup_done
set_town4:
	ld      bc, 303         ; size
	ld      hl, (townp+6)   ; pointer to compressed data
	ld      a, 38           ; width of map
	jr      town_setup_done
set_town5:
	ld      bc, 166         ; size
	ld      hl, (townp+8)   ; pointer to compressed data
	ld      a, 38           ; width of map

town_setup_done:
	call    uncom           ; fill out the (map) array
	ld      hl, (stampbase)
	ld      bc, 256
	add     hl, bc
	ld      (stampmem), hl
	jp      setup_done_uncom

remove_guy:
	ld      ix, ch+96
	ld      a, (ix+CX)
	sub     5
	ld      (ix+CX), a
	ld      (ix+SQX), a
	ret

cavebase        .db     0,0
setup_cave:
	; clear out the map with quitgrass (grass that makes u leave cave)
	ld      hl, (map)
	ld      bc, 2856
clr4cavelp:
	ld      (hl),15
	inc     hl
	dec     bc
	ld      a, b
	or a
	jr      nz, clr4cavelp
	ld      a, c
	or a
	jr      nz, clr4cavelp

	ld      a, (mapnum)
	sub     5
	ld      e, a
	ld      d, 0
	ld      hl, (cavep)
	ld      b, 72
caveplp:
	add     hl, de
	djnz    caveplp
	ld      (cavebase), hl

	ld      bc, 427
	ld      hl, (map)
	add     hl, bc
	ld      de, (cavebase)

	ld      b, 24
cavelp3:
	push    bc
	ld      b, 3
cavelp2:
	push    bc
	push    de
	ld      a, (de)
	ld      c, a
	ld      b, 8
cavelp1:
	ld      a, c
	and     128
	call    z, cave_set     ; zero bit indicates wall
	call    nz, cave_reset  ; anything else is a floor
	sla     c
	djnz    cavelp1

	pop     de
	pop     bc
	inc     de
	djnz    cavelp2

	ld      bc, 60
	add     hl, bc
	pop     bc
	djnz    cavelp3

	ld      a, (mapnum)
	cp      13
	call    z, addboss

	; setup etownx and etowny
	call    setup_xyexit

	ld      hl, (stampbase)
	ld      bc, 512
	add     hl, bc
	ld      (stampmem), hl
	jr      setup_done_uncom

cave_reset:
	ld      (hl),1
	inc     hl
	ret
cave_set:
	ld      (hl),11
	inc     hl
	ret
addboss:
	ld      c, 13
	ld      b, 12
	call    getmap
	ld      a, 2
	ld      (hl), a
	ld      c, 13
	ld      b, 13
	call    getmap
	ld      a, 3
	ld      (hl), a
	ret

setup_done_uncom:

	; flag the map w/ vision and boundaries
	; vision  boundary --------------stamp #---------------------
	; |  7 |  | 6    | |  5      4      3      2      1      0  |
	
	; do boundary
	ld      hl, (map)
	ld      bc, 0
map_flag_loop1:
	ld      a, (hl)
	ld      e, a
	and     15
	
	;cp      7
	;jr      nc, flag_boundary
	
	cp      7
	jp      z, flag_boundary
	cp      8
	jp      z, flag_boundary
	; town only
	cp      9
	jp      z, flag_boundary
	cp      10
	jp      z, flag_boundary
	cp      11
	jp      z, flag_boundary
	cp      12
	jp      z, flag_boundary
	cp      13
	jp      z, flag_boundary
	cp      14
	jp      z, flag_boundary

	jr      map_no_change1

flag_boundary:
	ld      a, e
	or      64
	ld      (hl), a
map_no_change1:
	inc     hl
	inc     bc

	ld      a, b
	cp      15h
	jr      nz, map_flag_loop1
	ld      a, c
	or      a
	jr      nz, map_flag_loop1
       
	; do vision
	ld      hl, (map)
	ld      bc, 0
map_flag_loop2:
	ld      a, (hl)
	ld      e, a
	and     15
	
	cp      6
	jr      z, flag_vision
	cp      8
	jr      z, flag_vision

	; town only
	;cp      9
	;jp      z, flag_vision
	cp      11
	jr      z, flag_vision
	cp      12
	jr      z, flag_vision
	
	jr      map_no_change2

flag_vision:
	ld      a, e
	or      128
	ld      (hl), a
map_no_change2:
	inc     hl
	inc     bc

	ld      a, b
	cp      15h
	jr      nz, map_flag_loop2
	ld      a, c
	or a
	jr      nz, map_flag_loop2

	; setup the variables
	ld      a, (ch+P1+CX)
	ld      (ch+P1+SQX), a
	ld      a, (ch+P1+CY)
	ld      (ch+P1+SQY), a
	
	ld      a, (ch+P2+CX)
	ld      (ch+P2+SQX), a
	ld      a, (ch+P2+CY)
	ld      (ch+P2+SQY), a
	
	ld      a, (ch+P3+CX)
	ld      (ch+P3+SQX), a
	ld      a, (ch+P3+CY)
	ld      (ch+P3+SQY), a
	
	ld      a, (ch+P4+CX)
	ld      (ch+P4+SQX), a
	ld      a, (ch+P4+CY)
	ld      (ch+P4+SQY), a

	; setup treasure chests
	ld      hl, (searchdata)
	ld      b, ITEMAMOUNT   ; number of items in game
setup_items:
	push    bc

	push    hl
	ld      hl, pickup
	ld      a, b
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	jr      nz, setup_ibad
	pop     hl

	push    hl
	ld      a, (maptype)
	cp      (hl)
	jr      nz, setup_ibad
	ld      a, (mapnum)
	inc     hl
	cp      (hl)
	jr      nz, setup_ibad
	inc     hl
	ld      a, (hl)
	ld      c, a
	inc     hl
	ld      a, (hl)
	ld      b, a
	call    getmap
	ld      (hl),12
setup_ibad:
	pop     hl
	ld      bc, 5
	add     hl, bc
	pop     bc
	djnz    setup_items

	; copy first frame of stamps into set
	ld      de, (stamps)
	ld      hl, (stampmem)
	ld      bc, 128
	ldir

	ret

setup_xyexit:
	ld      a, (mapnum)
	ld      e, a
	ld      d, 0
	ld      b, 7
	ld      hl, (townxy)
towndatlp2:
	add     hl, de
	djnz    towndatlp2
	ld      bc, 4
	add     hl, bc
	ld      a, (hl)
	ld      (etownx), a
	inc     hl
	ld      a, (hl)
	ld      (etowny), a
	ret

; rand - gets random number from 0 to A.  stores value into A.
rand:
	 push   bc
	 push   de
	 push   hl

	 push   af
	 call _RANDOM ;Calls Random
	 pop    af

	 call _SETXXOP2
	 call _FPMULT 
	 call _CONVOP1
	 ld     a, e
	 pop    hl
	 pop    de
	 pop    bc
	 ret
	
; getch - gets a keypress.  //save row:col in b:c
getch:
	;push    af
	push    de
	call    _GetK
	ld      a, (OP2+2)
	;ld      d, a
	;and     15
	;ld      c, a
	;ld      a, d
	;srl     a
	;and     15
	;ld      b, a
	pop     de
	;pop     af
	ret

; hitd - A=DIR, checks to see if there is a character in the way. A=result
hitd_dir        .db     0
hitd_char       .db     0
hitd:
	ld      (hitd_dir), a
	ld      a, (maptype)
	cp      TOWN
	jp      nz, after_upcp
	; check for character in the way
	ld      a, (nparty)
	ld      b, a
	ld      a, (chnum)
	sub     b
	ld      b, a
upcp_loop:
	push    bc
	ld      a, (nparty)
	dec     a
	add     a, b
	ld      (hitd_char), a
	call    getxy

	ld      a, (ch+SQY)
	ld      e, a
	ld      a, (hitd_dir)
	cp      UP
	jr      nz, hitd_noup
	dec     e
hitd_noup:
	cp      DOWN
	jr      nz, hitd_nodown
	inc     e
hitd_nodown:
	ld      a, e
	cp      b
	jp      nz, upcp_fail

	ld      a, (ch+SQX)
	ld      e, a
	ld      a, (hitd_dir)
	cp      LEFT
	jr      nz, hitd_noleft
	dec     e
hitd_noleft:
	cp      RIGHT
	jr      nz, hitd_noright
	inc     e
hitd_noright:
	ld      a, e
	cp      c
	jr      nz, upcp_fail

	pop     bc
	jr      upcp_bad
upcp_fail:
	pop     bc
	djnz    upcp_loop
	jr      after_upcp
upcp_bad:
	; this means that the player touched someone. what now?
	ld      hl, ch+DO
	ld      a, (hitd_char)
	ld      e, a
	ld      d, 0
	ld      b, 16
hitdadlp:
	add     hl, de
	djnz    hitdadlp
	ld      a, (hl)
	or a               ; is it a normal townsfolk?
	jr      z, hit_talker
	cp      1               ; is it a shopkeeper?
	jr      z, hit_shop
	cp      2               ; is it an innkeeper?
	jr      nz, hit_done
hit_inn:
	push    hl
	ld      a, 25
	call    talkbox
	pop     hl
	call    menu_inn
	ld      a, 0
	ret
hit_talker:
	inc     hl
	ld      a, (hl)
	cp      JEFFSTR
	jp      nz, hitd_normaltalk
	ld      a, (shards)
	cp      8
	jp      z, allowboat
hitd_normaltalk:
	ld      a, (hl)
	call    talkbox
	ld      a, 0
	ret
hit_shop:
	push    hl
	ld      a, 24
	call    talkbox
	pop     hl
	inc     hl
	ld      a, (hl)
	call    menu_shop
hit_done:
	ld      a, 0
	ret

; run this if you talk to jeff and you have all 8 shards
allowboat:
	ld      a, 63
	call    talkbox
	ld      c, 30
	ld      b, 48
	call    setparty
	ld      a, OVER
	ld      (maptype), a
	ld      a, 0
	ld      (mapnum), a
	call    clear_follow
	call    blank
	call    setup_map
	ld      a, 0
	ret

after_upcp:
	ld      a, 1
	ret

upon10:
	ld      a, (ch+SQY)
	dec     a
	ld      (ch+SQY), a
	ld      a, UP
	call    hitd
	ld      a, (ch+SQY)
	inc     a
	ld      (ch+SQY), a
	ret
rton10:
	ld      a, (ch+SQX)
	inc     a
	ld      (ch+SQX), a
	ld      a, RIGHT
	call    hitd
	ld      a, (ch+SQX)
	dec     a
	ld      (ch+SQX), a
	ret
lfon10:
	ld      a, (ch+SQX)
	dec     a
	ld      (ch+SQX), a
	ld      a, LEFT
	call    hitd
	ld      a, (ch+SQX)
	inc     a
	ld      (ch+SQX), a
	ret
dnon10:
	ld      a, (ch+SQY)
	inc     a
	ld      (ch+SQY), a
	ld      a, DOWN
	call    hitd
	ld      a, (ch+SQY)
	dec     a
	ld      (ch+SQY), a
	ret

; pixel - plots pixel at (A,E) of color 0 or 1
color   .db     1
pixel:
	push    af
	push    de
;   Calculate the address in graphbuf   

	ld      hl,0            ; Do y*12
	ld      d,0
	add     hl,de
	add     hl,de
	add     hl,de
	add     hl,hl
	add     hl,hl

	ld      d,0             ; Do x/8
	ld      e,a
	srl     e
	srl     e
	srl     e
	add     hl,de

	ld      de,8e29h
	add     hl,de           ; Add address to graphbuf

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	or a               ; Is this sprite aligned to 8*n,y?
	jr      z,pixalign


;   Non aligned sprite blit starts here   

	ld      d,a             ; d=how many bits to shift each line
	ld      b,128           ; Get sprite data
	ld      c,0             ; Shift loop
	push    de
pixshl: srl     b
	rr      c
	dec     d
	jr      nz,pixshl
	pop     de

	ld      a, (color)
	cp      1
	jr      z, pixelb

	ld      a,b
	xor     255
	and     (hl)
	ld      (hl), a
	jr      pixdone

pixelb:
	ld      a,b             ; Write line to graphbuf
	or      (hl)
	ld      (hl),a
	
	jr      pixdone

;   Aligned sprite blit starts here   

pixalign:                       ; Blit an aligned sprite to graphbuf
	ld      a, (color)
	cp      1
	jr      z, pixelb2

	ld      a,128
	xor     255
	and     (hl)
	ld      (hl),a
	jr      pixdone
pixelb2:
	ld      a,128
	or      (hl)            ; xor=erase/blit
	ld      (hl),a
pixdone:
	ld      a, 1
	ld      (color), a
	pop     de
	pop     af
	ret

; rect - draws a rectangle using the pixel function at (A,E), len=C, height=B
rectx   .db     0
recty   .db     0
rectw   .db     0
recth   .db     0
rect:
	push    af
	push    de
	ld      (rectx), a
	ld      a, e
	ld      (recty), a
	
	ld      a, c
	ld      (rectw), a
	ld      a, b
	ld      (recth), a

	ld      a, (rectw)
	ld      b, a
rect_loopx:
	push    bc
	ld      a, (recty)
	ld      e, a
	ld      a, (rectx)
	call    pixel
	ld      a, (recty)
	
	ld      d, a
	ld      a, (recth)
	add     a, d
	
	ld      e, a
	ld      a, (rectx)
	call    pixel
	ld      a, (rectx)
	inc     a
	ld      (rectx), a
	pop     bc
	djnz    rect_loopx
	
	pop     de
	pop     af
	ld      (rectx), a
	ld      a, e
	ld      (recty), a

	ld      a, (recth)
	inc     a
	ld      b, a
rect_loopy:
	push    bc
	ld      a, (recty)
	ld      e, a
	ld      a, (rectx)
	call    pixel
	ld      a, (recty)
	ld      e, a
	ld      a, (rectx)
	
	ld      d, a
	ld      a, (rectw)
	add     a, d
	
	call    pixel
	ld      a, (recty)
	inc     a
	ld      (recty), a
	pop     bc
	djnz    rect_loopy
	
	ret

; window - draws a window to fit B lines of text and has a pixel width of C
;        - draws topleft corner of window at pixel (A,E)
winstart        .db     0
winwid          .db     0
winline         .db     0
window:
	push    af
	push    bc
	push    de
	
	push    af
	ld      a, c
	inc     a
	ld      (winwid), a
	ld      a, b
	inc     a
	ld      (winline), a
	pop     af

	push    af
	push    de
	ld      (winstart), a
	ld      a, (winline)
	ld      b, a
winy:
	push    bc
	ld      a, (winwid)
	ld      b, a
	ld      a, (winstart)
winx:
	push    af
	push    bc
	push    de
	;ld      hl, _blackstamp
	;call    CLRSPR
	
	push    af
	xor a
	ld      (color), a
	pop     af
	call    pixel

	pop     de
	pop     bc
	pop     af

	inc     a
	djnz    winx
	
	inc     e
	pop     bc
	djnz    winy

	pop     de
	pop     af

	
	pop     de
	pop     bc
	pop     af

	push    af
	push    bc
	push    de

	call    rect
	
	pop     de
	pop     bc
	pop     af

	push    af
	push    bc
	push    de

	inc     a
	inc     a
	
	inc     e
	inc     e
	
	dec     c
	dec     c
	dec     c
	dec     c
	
	dec     b
	dec     b
	dec     b
	dec     b
	call    rect

	pop     de
	pop     bc
	pop     af

	ret

; text - prints a null-terminated string in hl at (a,e) using the font
textbakhl       .db     0, 0
textx           .db     0
text:
	ld      (textx), a
textloop:
	push    af
	push    de
	
	ld      a, (hl)
	or a
	jr      z, textdone
	cp      10
	jr      z, textnewline
	sub     32
	
	ld      (textbakhl), hl

	ld      d, 0
	ld      e, a
	ld      hl, (font)
	ld      b, 8
textadloop:
	add     hl, de
	djnz    textadloop

	pop     de
	pop     af
	
	push    af
	push    de
	call    DRWSPR
	ld      hl, (textbakhl)
	pop     de
	pop     af

	add     a, 4
	inc     hl
	jr      textloop
textdone:
	pop     de
	pop     af
	ret

textnewline:
	pop     de
	pop     af
	ld      a, e
	add     a, 6
	ld      e, a
	ld      a, (textx)
	inc     hl
	jr      textloop

; stext - like text, but prints string element C (instead of [hl]) at (A,E)
stext:
	push    af
	push    de
	
	ld      b, 0
	ld      hl, (strtable)
	add     hl, bc  ; 2xBC  ;-)
	add     hl, bc
	ld      a, (hl)                 ; ---\
	ld      (talkindex), a          ;    |
	inc     hl                      ;    |
	ld      a, (hl)                 ;    +-- gotta be a better way...
	ld      (talkindex+1), a        ;    |
	ld      bc, (talkindex)         ; ---/
	ld      hl, (str)
	add     hl, bc

	pop     de
	pop     af
	call    text

	ret

; itoa - integer to ascii.  bc=num, hl=output string
itoa_out        .db     0,0,0,0,0,0,0,0,0,0
itoa:
; // Function: dispint
; // Purpose:  display a decimal 8-bit unsigned int in menu font
; // Input:    A = value to display,  (B,C) = graphic coords
; // Coded by Don Barnes (donman)
;dispint:
	PUSH AF
	LD HL,itoa_out
	PUSH HL
	LD A,$30
	LD (HL),$30
	INC HL
	LD (HL),$30
	POP HL
	POP AF

	LD DE,2
	ADD HL,DE
	push bc

convloop:
	LD B,A
	call divide10
	LD A,B
	ADD A,$30
	LD (HL),A
	DEC HL
	LD A,C
	or a
	jr nz,convloop

	pop bc
	LD A,C
	LD H,A
	LD A,B
	LD L,A
	ld      hl, itoa_out
	ret

; // Function: divide10
; // Purpose:  SLOWLY divides an 8-bit integer by 10
; // Input:    B
; // Output:   B = remainder, C = integer result
; // Coded by Don Barnes
divide10:
	push af
	sub a
	ld c,a
div_2:
	ld a,b
	cp 10
	jr c,div_1
	inc c
	sub 10
	ld b,a
	jr div_2
div_1:
	pop af
	ret

; menupick - lets player select something from a list using the arrows.
;            A,E = (x,y) of list. C = num. on return, A = [2nd]=1 [Alpha]=0.
menux   .db     0
menuy   .db     0
menunum .db     0
omenux  .db     0
omenuy  .db     0
menupick:
	ld      (menux), a
	ld      a, e
	ld      (menuy), a
	dec     c
	ld      a, c
	ld      (menunum), a
	xor a
	ld      (index), a
menuloop:
	ld      a, (index)
	ld      c, a
	xor a
	ld      b, 6
curloop:
	add     a, c
	djnz    curloop
	ld      b, a
	ld      a, (menuy)
	add     a, b
	ld      (omenuy), a
	ld      e, a
	ld      a, (menux)
	ld      (omenux), a

	ld      hl, cursor
	call    DRWSPR
	
	call    BUFCOPY

	call    getch
	cp      31h
	jr      z, menucancel
	cp      25h
	call    z, indexup
	cp      34h
	call    z, indexdn
	cp      21h
	jr      z, menuaccept
	cp      45h
	jp      z, exit
	cp      11h
	call    z, pause

	ld      a, (omenuy)
	ld      e, a
	ld      a, (omenux)
	ld      hl, cursor
	call    CLRSPR
	
	jr      menuloop

menuaccept:
	ld      a, 1
	ret
menucancel:
	xor a
	ret
menudone:
	ret

indexup:
	push    af
	ld      a, (index)
	or      a
	jr      z, indexupw
	dec     a
	ld      (index), a
	pop     af
	ret
indexupw:
	ld      a, (menunum)
	ld      (index), a
	pop     af
	ret

indexdn:
	push    af
	ld      a, (menunum)
	ld      b, a
	ld      a, (index)
	cp      b
	jr      z, indexdnw
	inc     a
	ld      (index), a
	pop     af
	ret
indexdnw:
	xor     a
	ld      (index), a
	pop     af
	ret

; goldwin - shows your GP
goldstr .db     "G",0
goldwin:
	ld      a, 50
	ld      e, 50
	ld      c, 23
	ld      b, 12
	call    window

	ld      a, (gold)
	call    itoa
	ld      a, 54
	ld      e, 54
	call    text
	ld      a, 66
	ld      e, 54
	ld      hl, goldstr
	call    text
	ret

; menu - big bad subscreen routine.  calls a lot of other little functions
;        like window, text, and so on.
shardstr .db    "SHARDS-",0
slashstr .db    "/",0
dashstr .db     "-",0
index   .db     0
menu:
	call    READKEY
	xor a
	ld      (index), a

	xor a
	ld      e, 50
	ld      c, 40
	ld      b, 12
	call    window

	ld      a, 4
	ld      e, 54
	ld      hl, shardstr
	call    text
	ld      a, (shards)
	call    itoa
	inc     hl
	inc     hl
	ld      a, 32
	ld      e, 54
	call    text

	call    goldwin
	
	xor a
	ld      e, 0
	ld      c, 36
	ld      b, 30
	call    window

	ld      a, 9
	ld      e, 4
	ld      c, 29
	call    stext
	
	ld      a, 4
	ld      e, 4
	ld      c, 4            ; 4 options in the list
	call    menupick
	or a
	ret z

	ld      a, (index)
	or a
	call    z, menu_search
	cp      1
	jp      z, menu_ilist
	cp      2
	call    z, menu_status
	cp      3
	jp      z, menu_save
menu_quit:
	ret

searchstr .db   "YOU FIND ",0
nothing .db     "NOTHING",0
found_shardstr  .db     "A SHARD!",0
itemfound       .db     0
chestnum        .db     0
menu_search:
	; check and see if something is listed under those coordinates
	ld      b, ITEMAMOUNT   ; number of treasure chests
	ld      a, (ch+CX)
	ld      e, a
	ld      a, (ch+CY)
	ld      d, a
	ld      hl, (searchdata)
check_clist:
	push    bc

	; verify that it hasn't been picked up yet
	push    hl
	push    bc
	ld      hl, pickup
	ld      a, b
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	pop     bc
	or a
	jr      nz, check_clist_bad
	pop     hl

	push    hl
	ld      a, (maptype)
	cp      (hl)
	jr      nz, check_clist_bad
	ld      a, (mapnum)
	inc     hl
	cp      (hl)
	jr      nz, check_clist_bad
	inc     hl
	ld      a, e
	cp      (hl)
	jr      nz, check_clist_bad
	inc     hl
	ld      a, d
	cp      (hl)
	jr      nz, check_clist_bad
	inc     hl
	ld      a, (hl)         ; ok, a chest was found, load in its contents
	ld      (itemfound), a
	ld      a, b
	ld      (chestnum), a
	jr      check_clist_good

check_clist_bad:
	pop     hl
	ld      bc, 5
	add     hl, bc
	pop     bc
	djnz    check_clist

	call    msgbox
	ld      a, 48
	ld      e, 36
	ld      hl, nothing
	call    text
	
	jr      check_clist_done

check_clist_good:
	pop     hl
	pop     bc

	ld      a, (itemfound)
	cp      255             ; item #255 is shard
	jr      nz, search_inormal

	; give him the shard already
	ld      a, (shards)
	inc     a
	ld      (shards), a

	; display the "u found" msg
	call    msgbox
	ld      hl, found_shardstr
	ld      a, 48
	ld      e, 36
	call    text
	jr      search_ishard_done

search_inormal:
	ld      a, (itemnum)
	cp      8
	jp      z, need_iroom

	; put the item into player's itemlist
	ld      hl, items
	ld      a, (itemnum)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (itemfound)
	ld      (hl), a
	ld      a, (itemnum)
	inc     a
	ld      (itemnum), a

	; display the "u found" msg
	call    msgbox
	ld      a, (itemfound)
	ld      c, a
	ld      a, 48
	ld      e, 36
	call    stext

search_ishard_done:
	
	; tell game that the item has been picked up already
	ld      hl, pickup
	ld      a, (chestnum)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (hl),1

	; erase the chest from the map
	ld      a, (ch+CX)
	ld      c, a
	ld      a, (ch+CY)
	ld      b, a
	call    getmap
	ld      (hl),1

check_clist_done:

	ld      a, 12
	ld      e, 36
	ld      hl, searchstr

	call    text
	call    BUFCOPY
	call    wait4key
	ret

;savestr .db     "NOT ALLOWED TO",10,"SAVE.",0
savesuc .db     "GAME SAVED.",0
menu_save:
	call    msgbox

	;ld      a, (maptype)
	;cp      CAVE
	;ld      hl, savestr
	;jr      z, menu_saveno

	ld      ix, ch
	ld      hl, savedgame
	ld      b, 4
savelp:
	push    bc
	ld      a, (ix+CX)
	ld      (hl), a
	inc     hl
	ld      a, (ix+CY)
	ld      (hl), a
	inc     hl
	ld      a, (ix+TYPE)
	ld      (hl), a
	ld      bc, 3
	add     hl, bc

	ld      bc, 16
	add     ix, bc
	pop     bc
	djnz    savelp

	ld      hl, partydata
	ld      de, savedgame + 20
	ld      bc, 129
	ldir
	ld      hl, savesuc

menu_saveno:
	ld      a, 12
	ld      e, 36
	call    text
	
	call    BUFCOPY
	call    wait4key

	ret

m_stat1 .db     "      L",10,"HP   /  ",0
stat_xy .db      0, 0, 42,0, 0,30, 42,30
stat_index      .db     0,0
menu_status:
	push    ix
	ld      b, 4
	ld      c, 0
menu_statuslp:
	push    bc
	ld      b, 0
	ld      (stat_index), bc
	ld      ix, stat_xy
	add     ix, bc
	add     ix, bc
	ld      a, (ix)
	ld      e, (ix+1)
	ld      c, 42
	ld      b, 30
	call    window

	ld      hl, names
	ld      de, (stat_index)
	ld      b, 6
get_namelp:
	add     hl, de
	djnz    get_namelp

	ld      a, (ix+1)
	add     a, 4
	ld      e, a
	ld      a, (ix)
	add     a, 4
	call    text

	ld      hl, level
	ld      bc, (stat_index)
	add     hl, bc
	ld      a, (hl)
	call    itoa
	inc     hl
	ld      a, (ix+1)
	add     a, 4
	ld      e, a
	ld      a, (ix)
	add     a, 32
	call    text

	ld      a, (ix+1)
	add     a, 4
	ld      e, a
	ld      a, (ix)
	add     a, 4

	ld      hl, m_stat1
	call    text
	ld      hl, hp
	ld      bc, (stat_index)
	add     hl, bc
	ld      a, (hl)
	call    itoa
	inc     hl      ; only 2 digit number

	ld      a, (ix+1)
	add     a, 10
	ld      e, a
	ld      a, (ix)
	add     a, 16
	
	call    text
	ld      hl, hpmax
	ld      bc, (stat_index)
	add     hl, bc
	ld      a, (hl)
	call    itoa
	inc     hl      ; only 2 digit number
	
	ld      a, (ix+1)
	add     a, 10
	ld      e, a
	ld      a, (ix)
	add     a, 28
	call    text

	ld      hl, eqwep
	ld      bc, (stat_index)
	add     hl, bc
	ld      a, (hl)
	ld      c, a
	
	ld      a, (ix+1)
	add     a, 16
	ld      e, a
	ld      a, (ix)
	add     a, 4
	call    stext

	; see if player is mage
	ld      hl, ch+TYPE
	ld      de, (stat_index)
	ld      b, 16
get_typelp:
	add     hl, de
	djnz    get_typelp
	ld      a, (hl)
	cp      2               ; type 2 = mage
	jr      nz, stat_nomage
	ld      hl, p_ext
	ld      de, (stat_index)
	add     hl, de
	ld      a, (hl)
	call    itoa
	inc     hl

	ld      a, (ix+1)
	add     a, 16
	ld      e, a
	ld      a, (ix)
	add     a, 32
	call    text
stat_nomage:

	ld      hl, eqarm
	ld      bc, (stat_index)
	add     hl, bc
	ld      a, (hl)
	ld      c, a
	
	ld      a, (ix+1)
	add     a, 22
	ld      e, a
	ld      a, (ix)
	add     a, 4
	call    stext

	pop     bc
	inc     c
	dec     b
	jp      nz, menu_statuslp

	pop     ix

	call    BUFCOPY
	call    wait4key

	ret

player_sel      .db     0
item_sel        .db     0
item_val        .db     0
e_itemlist      .db     0,0     ; ptr to item's entry in player's itemlist
e_itemdata      .db     0,0     ; ptr to the itemdata entry of selected item
ilist_success   .db     0
menu_ilist:
	xor a
	ld      (ilist_success), a
	; get size of item list
	ld      a, (itemnum)
	or a
	jp      z, ilist_noitems
	ld      b, a
	ld      a, 6
ilist_size:
	add     a, 6
	djnz    ilist_size
	ld      b, a

	; show item list menu
	ld      a, 20
	ld      e, 0
	ld      c, 36
	;ld      b, 54
	call    window

	ld      a, (itemnum)
	ld      hl, items
	ld      b, a
	ld      e, 4
list_items:
	push    bc
	ld      a, (hl)
	inc     hl
	ld      c, a

	push    hl
	push    de
	ld      a, 29
	call    stext
	pop     de
	pop     hl

	ld      a, e
	add     a, 6
	ld      e, a

	pop     bc
	djnz    list_items

	ld      a, (itemnum)
	ld      c, a
	ld      a, 24
	ld      e, 4
	call    menupick
	or a
	ret z
	ld      a, (index)
	
	; fill up the item variables for use in a sec
	ld      (item_sel), a   ; store selected item (as # in the list)
	ld      hl, items
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (e_itemlist), hl
	ld      a, (hl)
	;dec     a
	ld      (item_val), a   ; store # of the actual item from itemdata
	ld      c, a
	ld      hl, (itemdata)
	add     hl, bc          ; wannabe 3xBC
	add     hl, bc
	add     hl, bc
	ld      (e_itemdata), hl        ; store ptr to the item's entry
	
	; show use/drop menu
	ld      a, 40
	ld      e, 0
	ld      c, 32
	ld      b, 18
	call    window
	ld      a, (item_val)
	cp      3
	jr      c, item_useitem         ; show use menu instead of equip?
	
	ld      c, 30
	jr      ilist_after_sel
item_useitem:
	ld      c, 31
ilist_after_sel:

	ld      a, 49
	ld      e, 4
	call    stext

	ld      a, 44
	ld      e, 4
	ld      c, 2
	call    menupick
	or a
	ret z
	ld      a, (index)              ; drop or equip?
	cp      1
	jp      z, menu_drop

	; show player list
	ld      a, 60
	ld      e, 0
	ld      c, 32
	ld      b, 30
	call    window

	ld      b, 4
	ld      c, 4
	ld      hl, names
ilist_namelp:
	push    bc
	push    hl
	ld      a, c
	ld      e, a
	ld      a, 69
	call    text
	pop     hl
	ld      bc, 6
	add     hl, bc
	pop     bc
	ld      a, c
	add     a, 6
	ld      c, a
	djnz    ilist_namelp


	ld      a, 64
	ld      e, 4
	ld      c, 4
	call    menupick
	or a
	ret z
	ld      a, (index)
	ld      (player_sel), a
	ld      c, a
	ld      b, 0
	ld      hl, hp
	add     hl, bc
	ld      a, (hl)
	or a
	jp      z, ilist_notalive

	; check for compatability
	ld      e, 1
	ld      a, (player_sel)
	or a
	jr      z, ilist_nofix
	ld      b, a
ilist_fix:
	sla     e
	djnz    ilist_fix
ilist_nofix:
	ld      hl, (e_itemdata)
	ld      a, (hl)
	and     e                       ; check and see if the player can use
	cp      e
	jr      nz, ilist_cant_use

	; get value of the item selected, put in b
	ld      a, (item_val)
	ld      b, a

	ld      hl, (e_itemdata)
	inc     hl              ; entry + 1 = type of item
	ld      a, (hl)
	or a               ; is it a healing item?
	jr      z, setheal
	cp      1               ; weapon?
	call    z, setwep
	cp      2               ; armor?
	call    z, setarm

	; hl should now point to current weapon or armor to be replaced
	ld      a, (hl)
	ld      c, a
	ld      a, b
	ld      (hl), a

	; put old item in list
	ld      hl, (e_itemlist)
	ld      a, c
	;inc     a
	ld      (hl), a

	ld      a, 1
	ld      (ilist_success), a

	ret 
	
ilist_cant_use:
	ld      a, 57
	call    talkbox
	ret
ilist_notalive:
	ld      a, 58
	call    talkbox
	ret
ilist_noitems:
	ld      a, 59
	call    talkbox
	ret

setheal:
	ld      a, 1
	ld      (ilist_success), a
	inc     hl              ; (entry+2) = strength of item (heal amount)
	ld      a, (hl)
	ld      d, a
	ld      a, (player_sel)
	ld      c, a
	ld      b, 0
	ld      hl, hp
	add     hl, bc
	ld      a, (hl)
	add     a, d
	ld      (hl), a
	ld      d, a
	ld      hl, hpmax
	add     hl, bc
	ld      a, (hl)
	cp      d
	jp      nc, menu_drop_yes; amount healed didn't exceed hpmax; quit now
	ld      hl, hp
	add     hl, bc
	ld      (hl), a         ; otherwise, set hp=hpmax
	jr      menu_drop_yes   ; sqeeze into another function for space

setwep:
	push    af
	push    bc
	ld      hl, eqwep
	ld      a, (player_sel)
	ld      c, a
	ld      b, 0
	add     hl, bc
	pop     bc
	pop     af
	ret
setarm:
	push    af
	push    bc
	ld      hl, eqarm
	ld      a, (player_sel)
	ld      c, a
	ld      b, 0
	add     hl, bc
	pop     bc
	pop     af
	ret

menu_drop:
	ld      a, 60
	ld      e, 0
	ld      c, 25
	ld      b, 18
	call    window

	ld      a, 69
	ld      e, 4
	ld      c, 32
	call    stext

	ld      a, 64
	ld      e, 4
	ld      c, 2
	call    menupick
	or a
	ret z
	ld      a, (index)
	cp      1
	jr      z, menu_drop_yes
	ret
menu_drop_yes:
	ld      a, (item_sel)
	ld      c, a
	ld      b, 0
	ld      hl, items
	add     hl, bc
	ld      b, 8
menu_droplp:
	inc     hl
	ld      a, (hl)
	dec     hl
	ld      (hl), a
	inc     hl
	djnz    menu_droplp
	ld      a, (itemnum)
	dec     a
	ld      (itemnum), a
	ret

; talkbox - show a msg, like talking to townsfolk, A=MSG#
talkindex       .db     0, 0
talkmsg .db     0
talkbox:
	ld      (talkmsg), a
	ld      a, 8
	ld      e, 32
	ld      c, 80
	ld      b, 30
	call    window

	ld      a, (talkmsg)
	ld      c, a
	
	ld      a, 12
	ld      e, 36
	call    stext
	
	call    BUFCOPY
	call    wait4key

	ret

; msgbox - puts a msgbox on the screen with no text in it.
msgbox:
	ld      a, 8
	ld      e, 32
	ld      c, 80
	ld      b, 30
	call    window

	ret

; wait4key - waits for player to press [2nd] or [Alpha]
wait4key:
	call    getch   ; clear out keyboard buffer (the whole 1 key) =)
wait4keylp:
	call    getch
	cp      21h
	ret z
	cp      31h
	ret z
	cp      45h
	jp      z, exit
	jr      wait4keylp

; menu_shop - menu list to buy items
shop_item       .db     0
shop_curdata    .db     0,0
menu_shop:
	ld      e, a
	ld      d, 0
	ld      hl, (shopdata)
	ld      b, 8
shopadlp:
	add     hl, de
	djnz    shopadlp
	ld      (shop_curdata), hl

	call    goldwin

	xor a
	ld      e, 0
	ld      c, 36
	ld      b, 30
	call    window
	ld      a, 36
	ld      e, 0
	ld      c, 19
	ld      b, 30
	call    window

	ld      b, 4
	ld      c, 0
	ld      e, 4
	ld      hl, (shop_curdata)
shoplp:
	push    bc
	push    hl
	push    de

	ld      a, (hl)
	inc     hl
	push    hl
	ld      c, a
	ld      a, 9
	call    stext
	pop     hl
	ld      a, (hl)
	call    itoa
	ld      a, 40
	pop     de
	push    de
	call    text

	pop     de
	ld      a, e
	add     a, 6
	ld      e, a
	pop     hl
	ld      bc, 2
	add     hl, bc
	pop     bc
	djnz    shoplp

	ld      a, 4
	ld      e, 4
	ld      c, 4            ; 4 options in the list
	call    menupick
	or      a
	ret     z
	ld      a, (itemnum)
	cp      8
	jp      z, need_iroom
	ld      a, (index)

	ld      c, a
	ld      b, 0
	ld      hl, (shop_curdata)
	add     hl, bc          ; wannabe 2xBC =)
	add     hl, bc
	ld      a, (hl)
	ld      (shop_item), a  ; store item
	inc     hl
	ld      a, (hl)         ; get cost
	ld      b, a
	ld      a, (gold)
	sub     b
	jp      c, need_gold
	ld      (gold), a
	ld      a, (itemnum)
	ld      c, a
	ld      b, 0
	ld      hl, items
	add     hl, bc
	ld      a, (shop_item)
	ld      (hl), a
	ld      a, (itemnum)
	inc     a
	ld      (itemnum), a
	jp      thank_you
shop_done:
	ret

; inn menu. 10G charge to player for staying.
menu_inn:
	call    goldwin

	xor a
	ld      e, 0
	ld      c, 25
	ld      b, 18
	call    window

	ld      a, 9
	ld      e, 4
	ld      c, 32
	call    stext

	ld      a, 4
	ld      e, 4
	ld      c, 2            ; 2 options in the list
	call    menupick
	or a
	jr      z, inn_done
	ld      a, (index)
	or a
	jr      z, inn_done
	ld      a, (gold)
	sub     10
	jp      c, need_gold
	ld      (gold), a
	
	ld      a, (hpmax)
	ld      (hp), a
	ld      a, (hpmax+1)
	ld      (hp+1), a
	ld      a, (hpmax+2)
	ld      (hp+2), a
	ld      a, (hpmax+3)
	ld      (hp+3), a

	ld      b, 4
	ld      c, 0
restore_mp_lp:
	push    bc
	ld      b, 0
	ld      hl, level
	add     hl, bc
	ld      a, (hl)
	add     a, (hl)
	call    chk99
	ld      hl, p_ext
	add     hl, bc
	ld      (hl), a
	pop     bc
	inc     c
	djnz    restore_mp_lp

	jr      thank_you
inn_done:
	ret

need_gold:
	ld      a, 26
	call    talkbox
	ret
need_iroom:
	ld      a, 27
	call    talkbox
	ret
thank_you:
	ld      a, 28
	call    talkbox
	ret

; restores data (copy 6000 bytes of current running program down to JASM)
res_data:
	ld      bc, 6768        ; 6000 bytes to copy
	ld      de, (map)       ; dest (JASM)
	ld      hl, 9327h       ; source (this program)
	ldir                    ; DO IT!
	ret

; clear_follow - makes it so party starts over (use when changing scenes)
clear_follow:
	ld      a, 4
	ld      (lastmovs), a
	ld      (lastmovs+1), a
	ld      (lastmovs+2), a
	xor a
	ld      (lastmovs+3), a
	ret
	
; blanks the screen out
blank:
	ld      hl, 8e29h
	ld      bc, 0
blank_loop:
	ld      (hl),255
	inc     hl
	inc     bc
	ld      a, b
	cp      3
	jr      nz, blank_loop
	call    BUFCOPY
	ret

; trans - cool screen transition, hl=new image
transtmp        .db     0,0
trans_src       .db     0,0
trans:
	ld      (trans_src), hl
	; the big-bad routine
	ld      b, 8
	push    ix
translp:
	push    bc
	ld      hl, 8e29h
	ld      ix, (trans_src)
	ld      b, 32
translp2:
	push    bc
	ld      b, 12
translp3_1:
	ld      a, (ix)
	sla     a
	ld      (ix), a
	rl      (hl)
	inc     hl
	inc     ix
	djnz    translp3_1
	ld      b, 12
translp3_2:
	ld      a, (ix)
	sra     a
	ld      (ix), a
	rr      (hl)
	inc     hl
	inc     ix
	djnz    translp3_2
	pop     bc
	djnz    translp2

	call    BUFCOPY
	call    delay
	pop     bc
	djnz    translp
	pop     ix
	ret

; mem_swap - swaps BC bytes between (HL) and (DE)
mem_swap:
swap_lp:
	push    bc
	ld      a, (hl)
	ld      b, a
	ld      a, (de)
	ld      (hl), a
	ld      a, b
	ld      (de), a
	pop     bc
	inc     de
	inc     hl
	dec     bc
	ld      a, b
	or a
	jr      nz, swap_lp
	ld      a, c
	or a
	jr      nz, swap_lp
	ret

; getwep - gets str of wep.  A=player, A=return power
getwep:
	push    bc
	ld      b, 0
	ld      c, a
	ld      hl, eqwep
	add     hl, bc
	ld      a, (hl)
	ld      hl, (itemdata)
	ld      c, a
	add     hl, bc          ; wannabe 3xBC
	add     hl, bc
	add     hl, bc
	inc     hl
	inc     hl
	ld      a, (hl)         ; store power
	pop     bc
	ret
; getarm - gets def of arm.  A=player, A=return power
getarm:
	push    bc
	ld      b, 0
	ld      c, a
	ld      hl, eqarm
	add     hl, bc
	ld      a, (hl)
	ld      hl, (itemdata)
	ld      c, a
	add     hl, bc          ; wannabe 3xBC
	add     hl, bc
	add     hl, bc
	inc     hl
	inc     hl
	ld      a, (hl)         ; store power
	pop     bc
	ret

; battle! - a = formation entry in form_table
bakscr  .db     0,0
tmpstr  .db     "  /     /     /     /",0
b_gotgold .db   "GOT    G.",0
turn_num        .db     0
target_num      .db     0
numbad          .db     0
form_num        .db     0
b_setxy .db     64,64,80,80, 8, 8, 8,24,24
	.db     20,36,20,36,16,28,40,20,36
sparkgra
	.db     00000000b
	.db     00100001b
	.db     01000010b
	.db     10111101b
	.db     01000010b
	.db     00100001b
	.db     00000000b
	.db     00000000b
firegra
	.db     00000111b
	.db     00011001b
	.db     01100010b
	.db     11000100b
	.db     11110100b
	.db     01111110b
	.db     00011111b
	.db     00000111b
wingold .db     0
winexp  .db     0
b_index .db     0
battle:
	ld      a, (maptype)
	cp      OVER
	jr      z, b_over
	cp      CAVE
	jr      z, b_cave
b_over:
	ld      a, (shards)
	sub     1
	call    c, b_under0
	ld      b, a
	add     a, b
	add     a, b
	ld      b, a
	jr      b_dorand
b_cave:
	ld      a, (mapnum)
	sub     5
	ld      b, a
	add     a, b
	add     a, b            ; multiply a*3 and store in b
	ld      b, a
b_dorand:
	ld      a, 4
	call    rand
	and     3
	cp      3
	jr      z, b_dorand

	ld      c, a
	ld      a, b
	add     a, c
battle_spec:
	ld      (form_num), a
	ld      de, b_x
	ld      hl, b_setxy
	ld      bc, 18
	ldir

	ld      a, (ch+TYPE+P1)
	ld      (b_type), a
	ld      a, (ch+TYPE+P2)
	ld      (b_type+1), a
	ld      a, (ch+TYPE+P3)
	ld      (b_type+2), a
	ld      a, (ch+TYPE+P4)
	ld      (b_type+3), a

	ld      b, 4
	ld      c, 0
b_weplp:
	push    bc
	ld      a, c
	call    getwep
	ld      b, 0
	ld      ix, p_str
	add     ix, bc
	ld      hl, b_str
	add     hl, bc
	ld      b, a
	ld      a, (ix)
	add     a, b
	ld      (hl), a

	ld      a, c
	call    getarm
	ld      b, 0
	ld      ix, p_def
	add     ix, bc
	ld      hl, b_def
	add     hl, bc
	ld      b, a
	ld      a, (ix)
	add     a, b
	ld      (hl), a

	ld      b, 0
	ld      ix, p_agl
	add     ix, bc
	ld      hl, b_agl
	add     hl, bc
	ld      a, (ix)
	ld      (hl), a

	pop     bc
	inc     c
	djnz    b_weplp

	ld      a, (form_num)
	ld      hl, (form_data)
	ld      b, 8
	ld      e, a
	ld      d, 0
b_getform:
	add     hl, de
	djnz    b_getform
	ld      a, (hl)
	ld      (numbad), a
	inc     hl
	ld      a, (hl)
	ld      (wingold), a
	inc     hl
	ld      a, (hl)
	ld      (winexp), a
	inc     hl
	ld      a, (numbad)
	ld      b, a
	ld      c, 4
	push    ix
b_setup_enemies:
	push    bc
	push    hl
	ld      a, (hl)
	ld      ix, b_type
	ld      b, 0
	add     ix, bc
	ld      (ix), a

	ld      hl, (enemydata)
	ld      b, 4
	ld      e, a
b_getenemy:
	add     hl, de
	djnz    b_getenemy

	ld      ix, b_hp
	ld      b, 0
	add     ix, bc
	ld      a, (hl)
	ld      (ix), a
	inc     hl

	ld      ix, b_str
	ld      b, 0
	add     ix, bc
	ld      a, (hl)
	ld      (ix), a
	inc     hl

	ld      ix, b_def
	ld      b, 0
	add     ix, bc
	ld      a, (hl)
	ld      (ix), a
	inc     hl

	ld      ix, b_agl
	ld      b, 0
	add     ix, bc
	ld      a, (hl)
	ld      (ix), a

	pop     hl
	inc     hl
	pop     bc
	inc     c
	djnz    b_setup_enemies
	pop     ix

	; sort loop for turn order
	call    b_getorder

	; copy screenbuf to side ram
	ld      hl, (map)
	;ld      de, 5376
	;add     hl, de
	ld      (bakscr), hl
	ld      de, (bakscr)
	ld      bc, 768
	ld      hl, 8e29h
	ldir
	call    battle_draw

	ld      bc, 768
	ld      hl, 8e29h
	ld      de, (bakscr)
	call    mem_swap

	ld      hl, (bakscr)
	call    trans

	xor     a
	ld      (b_index), a
battle_loop:
	ld      a, (b_index)
	ld      hl, b_order
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	ld      (turn_num), a

	call    getch
	;cp      31h
	;jp      z, battle_done
	call    battle_draw
	call    BUFCOPY

	; check and see if u lost
	ld      hl, b_hp
	ld      b, 4
b_lostlp:
	ld      a, (hl)
	cp      0
	jp      nz, b_notlost
	inc     hl
	djnz    b_lostlp
	jp      b_battle_lost
b_notlost:

	; check and see if you won
	ld      hl, b_hp+4
	ld      a, (numbad)
	ld      b, a
b_wonlp:
	ld      a, (hl)
	cp      0
	jp      nz, b_notwon
	inc     hl
	djnz    b_wonlp
	jp      battle_done
b_notwon:

	ld      hl, b_hp
	ld      a, (turn_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	jp      z, b_turndone

	ld      a, (turn_num)
	cp      4
	jp      nc,b_enemyturn
b_playerturn:
	ld      a, (turn_num)
	call    b_box
	xor a
	ld      e, 0
	ld      c, 36
	ld      b, 24
	call    window
	ld      a, 9
	ld      e, 4
	ld      c, 53
	call    stext
	ld      a, 4
	ld      e, 4
	ld      c, 3
	call    menupick
	or a
	jp      z, b_turndone
	ld      a, (index)
	or a
	jr      z, b_choose_target
	cp      1
	jp      z, b_ilist
	cp      2
	jp      z, b_run
b_choose_target:
	xor     a
	dec     a
	ld      (index), a
	ld      a, (numbad)
	dec     a
	ld      (menunum), a
	call    b_indexdn
b_chooselp:
	call    BUFCLR
	call    battle_draw
	ld      a, (turn_num)
	call    b_box
	ld      a, (index)
	add     a, 4
	call    b_box
	call    BUFCOPY
	call    getch
	cp      31h
	jp      z, battle_loop
	cp      25h
	call    z, b_indexup
	cp      34h
	call    z, b_indexdn
	cp      21h
	jr      nz,b_chooselp
b_choose_done:
	ld      a, (index)
	add     a, 4
	ld      (target_num), a

	; see if it's an archer
	ld      a, (turn_num)
	ld      c, a
	ld      b, 0
	ld      hl, b_type
	add     hl, bc
	ld      a, (hl)
	cp      1               ; type 1 = archer
	jr      z, b_attarch
	cp      2               ; type 2 = mage
	jp      z, b_attmage
	jp      b_attnorm
b_attarch:
	ld      a, 4
	call    rand
	and     3
	cp      1
	jp      nz, b_attnorm
	; get valuable archer data.... well, upstr, and then x and y
	ld      hl, b_str
	add     hl, bc
	ld      a, (hl)
	push    hl              ; save these
	push    af              ; till after turn so str can be reduced fast
	ld      e, a
	add     a, e            ; archer str doubles for this hit
	add     a, e
	ld      (hl), a

	ld      hl, b_y
	add     hl, bc
	ld      a, (hl)
	ld      e, a
	ld      hl, b_x
	add     hl, bc
	ld      a, (hl)
	sub     4
	ld      d, a

	ld      b, 6
archlp:
	push    bc

	push    de
	call    battle_draw
	pop     de

	push    de
	ld      a, d
	ld      hl, sparkgra
	call    DRWSPR
	call    BUFCOPY
	pop     de
	ld      a, d
	sub     8
	ld      d, a
	pop     bc
	djnz    archlp

	ld      a, (target_num)
	call    b_hit
	ld      a, (target_num)
	call    b_damage

	pop     af              ; from earlier
	pop     hl              ;      "
	ld      (hl), a         ; restore str

	jp      b_attfin
b_attmage:
	; check to see if mage has wand
	ld      hl, eqwep
	add     hl, bc
	ld      a, (hl)
	cp      13
	jp      z, b_wand

	; if not, check to see if mage has mana left
	ld      hl, p_ext
	add     hl, bc
	ld      a, (hl)
	or      a
	jp      z, b_attnorm

	dec     a
	ld      (hl), a
b_wand:
	; get valuable mage data.... well, x and y
	ld      hl, b_str
	add     hl, bc
	ld      a, (hl)
	push    hl              ; save these
	push    af              ; till after turn so str can be reduced fast
	ld      e, a
	add     a, e            ; mage str quadruples during fireball
	call    c, over255
	add     a, e
	call    c, over255
	add     a, e
	call    c, over255
	ld      (hl), a

	ld      hl, b_y
	add     hl, bc
	ld      a, (hl)
	ld      e, a
	ld      hl, b_x
	add     hl, bc
	ld      a, (hl)
	sub     4
	ld      d, a

	ld      b, 16
magelp:
	push    bc

	push    de
	call    battle_draw
	pop     de

	push    de
	ld      a, d
	ld      hl, firegra
	call    DRWSPR
	call    BUFCOPY
	pop     de
	ld      a, d
	sub     3
	ld      d, a
	pop     bc
	djnz    magelp

	ld      a, (target_num)
	call    b_hit
	ld      a, (target_num)
	call    b_damage

	pop     af              ; from earlier
	pop     hl              ;      "
	ld      (hl), a         ; restore str

	jp      b_attfin

b_attnorm:
	ld      a, (turn_num)
	call    b_hop
	ld      a, (target_num)
	call    b_hit
	ld      a, (target_num)
	call    b_damage

b_attfin:
	jp      b_turndone

b_ilist:
	call    menu_ilist
	ld      a, (ilist_success)
	or a
	jp      z, battle_loop
	jp      b_turndone
b_run:
	ld      a, (form_num)
	cp      27      ; boss battle
	jp      z, b_runfail
	ld      a, 4
	call    rand
	and     3
	cp      1
	jp      nz, b_runfail
	ld      a, 68
	call    talkbox
	jp      b_quit
b_runfail:
	ld      a, 67
	call    talkbox
	jp      b_turndone

b_enemyturn:
	;ld      a, 4
b_enemy_choose:
	ld      a, 4
	call    rand
	and     3
	ld      (target_num), a
	ld      hl, hp
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	jr      z, b_enemy_choose

	ld      a, (turn_num)
	call    b_hop
	ld      a, (target_num)
	call    b_hit
	call    b_damage
b_turndone:

	; done with loop?
	ld      a, (b_index)
	add     a, 2
	ld      b, a
	ld      a, (b_numord)
	cp      b
	jr      c, b_reset
b_noreset:
	ld      a, (b_index)
	inc     a
	jr      b_aftreset
b_reset:
	xor     a
b_aftreset:
	;ld      (turn_num), a
	ld      (b_index), a
	jp      battle_loop
battle_done:
	ld      a, (form_num)
	cp      27      ; boss battle
	jp      z, ending

	call    msgbox
	ld      b, 4
	ld      c, 0
	ld      a, 36
	ld      (target_num), a
b_explp:
	push    bc
	ld      hl, names
	ld      b, 0
	ld      d, 6
b_getname:
	add     hl, bc
	dec     d
	jr      nz, b_getname
	ld      a, (target_num)
	ld      e, a
	ld      a, 12
	call    text
	pop     bc

	push    bc
	ld      hl, hp
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	jp      z, b_explp_next

	ld      hl, exp
	add     hl, bc
	ld      a, (winexp)
	ld      b, a
	ld      a, (hl)
	inc     b
	sub     b
	jr      c, b_gainlevel
	inc     a
	ld      (hl), a
	jp      b_explp_next
b_gainlevel:
	pop     bc

	; advance level
	push    bc
	ld      hl, level
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	inc     a
	call    chk99
	ld      (hl), a

	; give some hpmax
	ld      a, 4
	call    rand
	and     3
	add     a, 2
	ld      d, a
	ld      hl, hpmax
	add     hl, bc
	ld      a, (hl)
	add     a, d
	call    chk99
	ld      (hl), a
	; give to hp also
	ld      hl, hp
	add     hl, bc
	ld      a, (hl)
	add     a, d
	call    chk99
	ld      (hl), a

	; give some str
	ld      hl, p_str
	add     hl, bc
	ld      a, 1
	call    rand
	and     1
	inc     a
	ld      d, a
	ld      a, (hl)
	add     a, d
	call    chk99
	ld      (hl), a

	; give some def
	ld      hl, p_def
	add     hl, bc
	ld      a, 1
	;call    rand
	;and     1
	ld      d, a
	ld      a, (hl)
	add     a, d
	call    chk99
	ld      (hl), a

	; give some agl
	ld      hl, p_agl
	add     hl, bc
	ld      a, 1
	call    rand
	and     1
	inc     a
	ld      d, a
	ld      a, (hl)
	add     a, d
	call    chk99
	ld      (hl), a

	; if mage, advance ext
	ld      hl, p_ext
	add     hl, bc
	ld      a, (hl)
	add     a, 2
	call    chk99
	ld      (hl), a
	pop     bc

	push    bc
	ld      a, c
	call    getexp4next
	ld      a, (target_num)
	ld      e, a
	ld      a, 52
	ld      c, 56
	call    stext
b_explp_next:
	pop     bc

	; display exp needed
	push    bc
	ld      b, 0
	ld      hl, exp
	add     hl, bc
	ld      a, (hl)
	call    itoa
	ld      a, (target_num)
	ld      e, a
	ld      a, 36
	call    text
	pop     bc

	ld      a, (target_num)
	add     a, 6
	ld      (target_num), a
	inc     c
	dec     b
	jp      nz, b_explp

	call    BUFCOPY
	call    wait4key

	ld      a, (gold)
	ld      b, a
	ld      a, (wingold)
	add     a, b
	call    c, over255
	ld      (gold), a

	call    msgbox
	ld      a, 12
	ld      e, 36
	ld      hl, b_gotgold
	call    text
	ld      a, (wingold)
	call    itoa
	ld      a, 28
	ld      e, 36
	call    text
	call    BUFCOPY
	call    wait4key
b_quit:
	ld      b, 4
	ld      c, 0
b_revivelp:
	push    bc
	ld      hl, hp
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	call    z, b_under1
	ld      (hl), a
	pop     bc
	inc     c
	djnz    b_revivelp
	call    setup_map
	ret
b_battle_lost:
	call    blank
	call    BUFCOPY
	ld      a, 55
	call    talkbox
	jp      exit
over255:
	ld      a, 255
	ret

b_count .db     0
b_tmpx  .db     0
battle_draw:
	; copy real hp over to battle hp (in case someone healed)
	;push    ix
	;push    iy
	;ld      ix, b_hp
	;ld      iy, hp
	;ld      a, (iy)
	;ld      (ix), a
	;ld      a, (iy+1)
	;ld      (ix+1), a
	;ld      a, (iy+2)
	;ld      (ix+2), a
	;ld      a, (iy+3)
	;ld      (ix+3), a
	;pop     iy
	;pop     ix

	ld      a, (hp)
	ld      (b_hp), a
	ld      a, (hp+1)
	ld      (b_hp+1), a
	ld      a, (hp+2)
	ld      (b_hp+2), a
	ld      a, (hp+3)
	ld      (b_hp+3), a
	call    BUFCLR
	xor a
	ld      e, 48
	ld      c, 95
	ld      b, 14
	call    rect

	ld      a, 2
	ld      e, 56
	ld      hl, tmpstr
	call    text

	ld      hl, names
	xor a
	ld      (b_count), a
	ld      a, 2
	ld      (b_tmpx), a
b_statlp:
	push    hl
	ld      a, (b_tmpx)
	ld      e, 50
	call    text
	ld      hl, hp
	ld      a, (b_count)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	call    itoa
	ld      a, (b_tmpx)
	ld      e, 56
	inc     hl              ; 2 digit only, please
	call    text

	ld      hl, hpmax
	ld      a, (b_count)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	call    itoa
	ld      a, (b_tmpx)
	add     a, 12
	ld      e, 56
	inc     hl              ; 2 digit only, please
	call    text
	pop     hl

	ld      a, (b_tmpx)
	add     a, 24
	ld      (b_tmpx), a

	ld      bc, 6
	add     hl, bc

	ld      a, (b_count)
	inc     a
	ld      (b_count), a
	cp      4
	jr      nz, b_statlp


	ld      de, 8e29h
	ld      hl, (bat1_gra)
	ld      bc, 192
	ldir

	ld      a, (numbad)
	add     a, 4
	ld      d, a
	ld      bc, 0
b_drawlp:
	push    bc
	ld      hl, b_hp
	add     hl, bc
	pop     bc
	ld      a, (hl)
	or a
	jp      z, b_nodraw


	push    bc
	ld      hl, b_type
	add     hl, bc

	ld      a, c
	cp      4
	jr      nc, b_enemy

	ld      a, (hl)
	ld      c, a
	ld      b, 0
	ld      hl, (chars)
	ld      e, 16
b_addlp:
	add     hl, bc
	dec     e
	jr      nz, b_addlp
	jr      b_typedone
b_enemy:
	ld      a, (hl)
	ld      c, a
	ld      b, 0
	ld      hl, (enemy_gra)
	ld      e, 8
b_enemyaddlp:
	add     hl, bc
	dec     e
	jr      nz, b_enemyaddlp
b_typedone:
	pop     bc

	push    hl
	ld      hl, b_y
	add     hl, bc
	ld      a, (hl)
	ld      e, a
	ld      hl, b_x
	add     hl, bc
	ld      a, (hl)
	pop     hl

	push    de
	push    bc
	call    DRWSPR
	pop     bc
	pop     de
b_nodraw:
	inc     bc
	dec     d
	jr      nz, b_drawlp
	ret

; b_hop - a=char to hop
b_hop:
	ld      c, a
	ld      b, 0
	ld      hl, b_y
	add     hl, bc
	ld      b, 4
b_attlp1:
	push    bc
	push    hl
	call    battle_draw
	call    BUFCOPY
	pop     hl
	pop     bc
	ld      a, (hl)
	dec     a
	ld      (hl), a
	djnz    b_attlp1
	ld      b, 4
b_attlp2:
	push    bc
	push    hl
	call    battle_draw
	call    BUFCOPY
	pop     hl
	pop     bc
	ld      a, (hl)
	inc     a
	ld      (hl), a
	djnz    b_attlp2
	ret
	
; b_hit - a=char to get hit
b_hit:
	ld      c, a
	ld      b, 0
	ld      hl, b_x
	add     hl, bc

	ld      b, 4
b_targlp1:
	push    bc
	push    hl
	call    battle_draw
	call    BUFCOPY
	pop     hl
	pop     bc
	ld      a, c
	cp      4
	call    c, b_right
	call    nc, b_left
	djnz    b_targlp1

	ld      b, 4
b_targlp2:
	push    bc
	push    hl
	call    battle_draw
	call    BUFCOPY
	pop     hl
	pop     bc
	ld      a, c
	cp      4
	call    c, b_left
	call    nc, b_right
	djnz    b_targlp2
	ret
b_right:
	push    af
	ld      a, (hl)
	inc     a
	ld      (hl), a
	pop     af
	ret
b_left:
	push    af
	ld      a, (hl)
	dec     a
	ld      (hl), a
	pop     af
	ret

; b_box - put a box around char A
b_box_num       .db     0
b_box:
	ld      (b_box_num), a
	ld      hl, b_y
	ld      a, (b_box_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	sub     2
	ld      e, a
	
	ld      hl, b_x
	ld      a, (b_box_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	sub     2

	ld      c, 11
	ld      b, 11
	call    rect
	ret

damage  .db     0
b_damage:
	ld      hl, b_def
	ld      a, (target_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	ld      e, a

	ld      hl, b_str
	ld      a, (turn_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	sub     e
	call    z, b_under1
	call    c, b_under1
	ld      (damage), a

	ld      hl, b_hp
	ld      a, (target_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (damage)
	ld      b, a
	ld      a, (hl)
	sub     b
	call    c, b_under0
	ld      (hl), a         ; change target's hp
	ld      a, (target_num)
	cp      4
	jp      c, b_damage_player
	ret

b_damage_done:
	xor a
	ret
b_damage_player:
	ld      hl, b_hp
	ld      a, (target_num)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	ld      hl, hp
	add     hl, bc
	ld      (hl), a
	jr      b_damage_done

b_under1:
	ld      a, 1
	ret
b_under0:
	xor a
	ret

b_indexup:
	push    af
b_re_indexup:
	call    indexup
	ld      a, (index)
	add     a, 4
	ld      c, a
	ld      b, 0
	ld      hl, b_hp
	add     hl, bc
	ld      a, (hl)
	cp      0
	jp      z, b_re_indexup
	pop     af
	ret
b_indexdn:
	push    af
b_re_indexdn:
	call    indexdn
	ld      a, (index)
	add     a, 4
	ld      c, a
	ld      b, 0
	ld      hl, b_hp
	add     hl, bc
	ld      a, (hl)
	cp      0
	jp      z, b_re_indexdn
	pop     af
	ret

; getexp4next - resets char A's exp level to what is needed for current level
;             - just ++(level), then call this function to fill in (exp)
getexp4next:
	push    af
	ld      hl, ch+TYPE
	ld      e, a
	ld      d, 0
	ld      b, 16
getplayertype:
	add     hl, de
	djnz    getplayertype
	ld      a, (hl)
	ld      e, a
	pop     af

	ld      hl, level
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)

	push    af
	push    bc
	ld      hl, levelup
	ld      a, e
	ld      c, a
	add     hl, bc
	ld      a, (hl)
	ld      e, a
	pop     bc
	pop     af

	;ld      a, e
	ld      b, a
	xor     a
getexplp:
	add     a, e
	call    c, over255      ; if over 255, then = 255
	djnz    getexplp

	ld      hl, exp
	ld      b, 0
	add     hl, bc
	ld      (hl), a
	ret

b_used  .db     0,0,0,0,0,0,0,0,0
b_numused       .db     0
b_high_amount   .db     0
b_high_num      .db     0
b_numord        .db     0
b_getorder:
	;jp      new_method
	ld      b, 9
	xor a
	ld      hl, b_used
b_clrused:
	ld      (hl), a
	inc     hl
	djnz    b_clrused
	xor a
	ld      (b_numused), a
	ld      (b_numord), a

	push    ix
	ld      ix, b_order
b_getorderlp:
	ld      a, (numbad)
	add     a, 4
	ld      b, a
	ld      c, 0
	xor a
	ld      (b_high_amount), a
	ld      (b_high_num), a
b_getagl:
	push    bc
	ld      a, c
	ld      hl, b_used
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (hl)
	or a
	jr      nz, b_getnextagl
	pop     bc

	push    bc
	ld      hl, b_agl
	ld      b, 0
	add     hl, bc
	ld      a, (b_high_amount)
	ld      e, a
	ld      a, (hl)
	cp      e
	jr      c, b_getnextagl
	ld      (b_high_amount), a
	ld      a, c
	ld      (b_high_num), a
b_getnextagl:
	pop     bc
	inc     c
	djnz    b_getagl

	; check and see if player is a thief
	;ld      a, (b_high_num)
	;cp      4
	;jp      nc, b_nothief

	;ld      hl, b_type
	;ld      c, a
	;ld      b, 0
	;add     hl, bc
	;ld      a, (hl)
	;or a               ; type 0 = thief
	;jp      nz, b_nothief

	;ld      a, (b_high_num)
	;ld      (ix), a
	;inc     ix

	;ld      a, (b_numord)
	;inc     a
	;ld      (b_numord), a
;b_nothief:
	ld      a, (b_high_num)
	ld      hl, b_used
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      (hl),1

	ld      a, (b_high_num)
	ld      (ix), a
	inc     ix

	ld      a, (b_numord)
	inc     a
	ld      (b_numord), a

	ld      a, (numbad)
	add     a, 4
	ld      b, a

	ld      a, (b_numused)
	inc     a
	ld      (b_numused), a
	cp      b
	jp      nz, b_getorderlp
	pop     ix

	ret

pause:
	;di                      ; disable interrupts
	;ld      a, 001h
	;out     (003h), a       ; turn off screen
	;ld      a, 000h
	;out     (004h), a
	;ex      af, af'
	;exx
	;ei                      ; enable interrupts
	ret

atindex .db     0
atcursor        .db     0
name_type       .db     0
namep           .db     0,0
typep           .db     0,0
name_party:
	call    blank
	ld      a, 5
	ld      e, 5
	ld      c, 40
	ld      b, 17
	call    window

	ld      hl, names
	ld      (namep), hl
	ld      hl, ch+TYPE
	ld      (typep), hl
	ld      b, 4
name_player:
	push    bc
	ld      hl, (typep)
	ld      a, (hl)
	ld      (name_type), a
	ld      a, 0
	ld      (atcursor), a
	ld      (atindex), a
name_lp:
	call    inputchar
	ld      a, (atindex)
	cp      5
	jp      nz, name_lp
	ld      hl, (namep)
	ld      bc, 6
	add     hl, bc
	ld      (namep), hl
	ld      hl, (typep)
	ld      bc, 16
	add     hl, bc
	ld      (typep), hl
	pop     bc
	djnz    name_player
	ret

inputchar:
	ld      a, 26
	ld      (menunum), a
	ld      a, 1
	ld      (index), a
inputlp:
	ld      a, (atindex)
	ld      hl, (namep)
	ld      c, a
	ld      b, 0
	add     hl, bc
	ld      a, (index)
	add     a, 64
	ld      (hl), a
	inc     hl
	ld      a, 0
	ld      (hl), a

	call    draw_getname
	call    getch
	cp      25h
	call    z, indexdn
	cp      34h
	call    z, indexup
	cp      21h
	jp      z, input_done
	cp      31h
	jp      z, input_bs
	cp      45h
	jp      z, exit
	jp      inputlp
input_done:
	ld      a, (atindex)
	inc     a
	ld      (atindex), a
	ld      a, (atcursor)
	add     a, 4
	ld      (atcursor), a
	ret
input_bs:
	ld      a, (atindex)
	cp      0
	jp      z, inputlp
	dec     a
	ld      (atindex), a
	ld      a, (atcursor)
	sub     4
	ld      (atcursor), a
	ret

underscore      .db     "_",0
draw_getname:
	;call    BUFCLR
	ld      b, 4
	ld      c, 10
nameclrlp:
	push    bc
	ld      a, c
	ld      e, 10
	ld      hl, _blackstamp
	call    CLRSPR
	pop     bc
	ld      a, c
	add     a, 8
	ld      c, a
	djnz    nameclrlp

	ld      a, (name_type)
	ld      b, 0
	ld      c, a
	ld      hl, char_offsets
	add     hl, bc
	ld      c, (hl)
	ld      hl, (chars)
	add     hl, bc
	ld      a, 10
	ld      e, 10
	call    DRWSPR
	ld      hl, (namep)
	ld      a, 22
	ld      e, 11
	call    text
	ld      hl, underscore
	ld      a, (atcursor)
	add     a, 22
	ld      e, 13
	call    text
	call    BUFCOPY
	ret

; setchar - puts party at C,B on the map
setparty:
	ld      a, c
	ld      (ch+P1+CX), a
	ld      a, b
	ld      (ch+P1+CY), a
	
	ld      a, c
	ld      (ch+P2+CX), a
	ld      a, b
	ld      (ch+P2+CY), a
	
	ld      a, c
	ld      (ch+P3+CX), a
	ld      a, b
	ld      (ch+P3+CY), a

	ld      a, c
	ld      (ch+P4+CX), a
	ld      a, b
	ld      (ch+P4+CY), a
	ret

ending:
	ld      a, 65
	call    talkbox
	call    blank
	ld      a, 66
	call    talkbox
	ld      a, 61
	call    bigtext
	jp      exit

bigtext:
	push    af
	call    BUFCLR
	ld      a, 0
	ld      e, 0
	ld      c, 94
	ld      b, 62
	call    rect
	pop     af
	ld      c, a
	ld      a, 2
	ld      e, 2
	call    stext
	call    BUFCOPY
	call    wait4key
	ret

; setup_players - puts compressed player data into ch.
;               - hl = data, ix = ch, b = number of players
setup_players:
	ld      c, 0
setup_npc_loop:
	push    bc
	push    hl
	ld      a, (hl)
	inc     hl
	ld      (ix+CX), a
	ld      (ix+SQX), a
	ld      a, (hl)
	inc     hl
	ld      (ix+CY), a
	ld      (ix+SQY), a
	ld      a, (hl)
	inc     hl
	ld      (ix+TYPE), a
	ld      a, (hl)
	inc     hl
	ld      (ix+DO), a
	ld      a, (hl)
	inc     hl
	ld      (ix+MSG), a
	pop     hl
	ld      bc, 5
	add     hl, bc
	ld      bc, 16
	add     ix, bc
	pop     bc
	inc     c
	djnz    setup_npc_loop
	ret

chk99:
	cp      100
	ret     c
	ld      a, 99
	ret

;Ŀ
; Z80 ۳      DATA      ۳ jman  ۳
;
ssx     .db     0       ; stamp index in x-direction for draw_map
ssy     .db     0       ; stamp index in y-direction for draw_map
sox     .db     0       ; offset x into stamp for draw_map (0-7)
soy     .db     0       ; offset y into stamp for draw_map (0-7)
animtimer       .db     0
mademove        .db     0

chnum   .db     0       ; number of total characters on-screen (party + folk)
nparty  .db     4       ; number of partymembers
surround .db    0, 0, 0, 0 ; who is next to player(up,down,left,right)0=None

; CH            CX  CX  OX  OY  T  M  D  C  R  SQX SQY    DO MSG    EXTRA
ch      .db     11,  8,  0,  0, 3, 0, 0, 0, 4,   0,  0,    0,  0,   0,0,0
	.db     11,  8,  0,  0, 1, 0, 0, 0, 4,   0,  0,    0,  0,   0,0,0
	.db     11,  8,  0,  0, 2, 0, 0, 0, 4,   0,  0,    0,  0,   0,0,0
	.db     11,  8,  0,  0, 0, 0, 0, 0, 4,   0,  0,    0,  0,   0,0,0

	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0
	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0
	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0
	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0
	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0
	.db      0,  0,  0,  0, 0, 0, 0, 0, 0,   0,  0,    0,  0,   0,0,0

towndata        .db     0, 0

; PARTY VARS (to save the game, just save the following bytes +
;             top 4 lines of [ch])
partydata:
maptype .db     0
mapnum  .db     0
boat    .db     0
lastmovs        .db     4,4,4,0 ; None, 3 times
names   .db     "JUSTN",0
	.db     "DAVID",0
	.db     "MIKE ",0
	.db     "BRAD ",0
level   .db     1,1,1,1
hp      .db     15,10,5,10
hpmax   .db     15,10,5,10
p_str   .db     1,0,1,1
p_def   .db     1,0,0,0
p_agl   .db     0,1,0,4
p_ext   .db     0,0,3,0

	.db     0,0,0,0 ;pad cuz something is hitting exp...
			;never found out the cause...grr...this will do.

exp     .db     0,0,0,0
eqwep   .db     3,10,12,14
eqarm   .db     20,17,17,18
itemnum .db     8
items   .db     0,4,11,13,15,18,19,21
	.db     0,0,0,0,0,0,0,0         ; pad makes life easier when dropping
shards  .db     0
gold    .db     10
; 30 items
pickup  .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
; extra data for secrets... if i get to that
extra   .db     0,0,0,0,0

; NEW GAME DATA!
newgame
	; 20 bytes into ch
	.db     11,  8,  3, 0, 0
	.db     11,  8,  1, 0, 0
	.db     11,  8,  2, 0, 0
	.db     11,  8,  0, 0, 0
	; 129 bytes of party data
	.db     TOWN
	.db     2
	.db     0
	.db     4,4,4,0 ; none, 3 times
	.db     "JUSTN",0
	.db     "DAVID",0
	.db     "MIKE ",0
	.db     "BRAD ",0
	.db     1,1,1,1
	.db     15,10,5,10
	.db     15,10,5,10
	.db     1,0,1,1
	.db     1,0,0,0
	.db     0,1,0,4
	.db     0,0,2,0

	.db     0,0,0,0 ;pad cuz something is hitting exp...
			;never found out the cause...grr...this will do.

	.db     0,0,0,0
	.db     3,8,12,14
	.db     17,17,17,17
	.db     0
	.db     0,4,11,13,15,18,19,21
	.db     0,0,0,0,0,0,0,0         ; pad makes life easier when dropping
	.db     0
	.db     10
; 30 items
	.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
; extra data for secrets... if i get to that
	.db     0,0,0,0,0

; SAVED GAME DATA!
savedgame
	; 20 bytes into ch
	.db     11,  8,  3, 0, 0
	.db     11,  8,  1, 0, 0
	.db     11,  8,  2, 0, 0
	.db     11,  8,  0, 0, 0
	; 129 bytes of party data
	.db     TOWN
	.db     2
	.db     0
	.db     4,4,4,0 ; none, 3 times
	.db     "JUSTN",0
	.db     "DAVID",0
	.db     "MIKE ",0
	.db     "BRAD ",0
	.db     1,1,1,1
	.db     15,10,5,10
	.db     15,10,5,10
	.db     1,0,1,1
	.db     1,0,0,0
	.db     0,1,0,4
	.db     0,0,2,0

	.db     0,0,0,0 ;pad cuz something is hitting exp...
			;never found out the cause...grr...this will do.

	.db     12,14,15,10
	.db     3,8,12,14
	.db     17,17,17,17
	.db     0
	.db     2,2,2,2,2,2,2,2
	.db     0,0,0,0,0,0,0,0         ; pad makes life easier when dropping
	.db     0
	.db     10
; 30 items
	.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
; extra data for secrets... if i get to that
	.db     0,0,0,0,0

; BATTLE VARS (9 in each row: 4 chars + up to 5 enemies)
b_x     .db     64,64,80,80, 8, 8, 8,24,24
b_y     .db     20,36,20,36,16,28,40,20,36
b_str   .db      0, 0, 0, 0, 0, 0, 0, 0, 0
b_def   .db      0, 0, 0, 0, 0, 0, 0, 0, 0
b_agl   .db      0, 0, 0, 0, 0, 0, 0, 0, 0
b_type  .db      0, 0, 0, 0, 0, 0, 0, 0, 0
b_hp    .db      0, 0, 0, 0, 0, 0, 0, 0, 0

b_order .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; level up multiplier [thief,archer,mage,knight]
levelup .db     10,14,15,12

; STD VARS
x       .db     0, 0
y       .db     0, 0
pp1     .db     0, 0    ; tmp pointer1
pp2     .db     0, 0    ; tmp pointer2
dat     .db     0, 0    ; pointer to ZJDATA
map     .db     0, 0    ; pointer to MAP
townp   .db     0, 0    ; town pointers
	.db     0, 0
	.db     0, 0
	.db     0, 0
	.db     0, 0
cavep   .db     0, 0

cmap    .db     0, 0    ; pointer to compressed map

stampmem .db    0, 0    ; pointer to current set of stamps
stampbase .db   0, 0    ; pointer to the start of stamps
chars   .db     0, 0    ; pointer to character graphics
enemy_gra .db   0, 0    ; pointer to enemy graphics
font    .db     0, 0    ; pointer to the font
str     .db     0, 0    ; pointer to the all the strings in the game
strtable .db    0, 0    ; pointer to the table of strings

cursor  .db     192,224,240,224,192,0,0,0       ; cursor graphic

; for use with the view routine
xfix    .db     0
yfix    .db     0

; for use with the towns
etownx  .db     0
etowny  .db     0

; ----------------------------------------------------------------
; defines that will never change, but i'm too lazy to move to jext
; ----------------------------------------------------------------
; multiples of 13 (this way there's no need to multiply later)
view_offsets    .db     0,13,26,39,52,65,78,91,104,117
		.db     130,143,156,169,182,195,208,221,234,247

; multiples of 16 (same idea)
char_offsets    .db     0,16,32,48,64,80,96,112,128,144,160,176,192

;scratch .db     "ZJRAM2",0,0,0,0
;scratch .db     "ZJASM",0,0,0,0
;zjdata  .db     "ZJDATA" ,0,0,0

; -------------------------------------------------------
; Here lied a ton of data. It can now be found in jext.c.
; Their pointer equivalents are below.
; -------------------------------------------------------
townxy          .db     0, 0
searchdata      .db     0, 0
shopdata        .db     0, 0
itemdata        .db     0, 0
view            .db     0, 0
enemydata       .db     0, 0
form_data       .db     0, 0
bat1_gra        .db     0, 0
title_gra       .db     0, 0

; -------------------------
; these are pointers to ram
; -------------------------
stamps          .db     0, 0    ; holds current frame of stamp set
stamp_ok        .db     0, 0    ; pointer to "ok to draw" array (for vision)

; don't know why i need this... but it seems to make the game run right...
pad             .db     0, 0


; backup of sp. this way, program can bail no matter how deep stack is.
spbackup        .db     0, 0

;Ŀ
; Z80 ۳     EQUALS     ۳ jman  ۳
;

WAITKEY .equ     4CFEh  ; Wait for a key and read
BUFCLR  .equ     515Bh  ; Clear the graph backup
BUFCOPY .equ     5164h  ; Copy the graph backup to the screen
RINDOFF .equ     4795h  ; Turn off runindicator
PRINTHL .equ     4709h  ; Print HL in dec. on the screen
OP2TOP1 .equ     41C2h  ; Move OP2 to OP1
CONVOP1 .equ     4EFCh  ; Convert fp value in OP1 to a 2 byte hex
READKEY .equ     4A18h  ; Read key and place it in OP2 as a fp value
GOHOME  .equ     47A1h  ; Go to home screen (finish gfx program)
CLRTSHD .equ     4765h  ; Clear text shadow
HOMEUP  .equ     4775h  ; Place cursor at home
STRING  .equ     470Dh  ; Print 0 terminated string to screen (hl->string)

;Ŀ
; Z80 ۳  Joltima !!!!  ۳ jman  ۳
;


