/*      JEXT.C (Joltima EXTention)
        This is a C program that generates the file ZJTEXT.BIN

        ZJTEXT.BIN is a data file that holds all of Joltima's non-map and
        non-graphics data. This includes all text, character positions,
        cave+town locations, and any other such data that is difficult
        to generate without the aid of some program that I don't feel
        like making. This data is not in the original source because of
        TI83 memory limitations. It is more efficient for Joltima to leech
        off of a data file than to have the data in two different spots
        after loading the program.

        This file also generates other .BIN files necessary to Joltima.

        note: this file is pretty messy.
*/

#include<stdio.h>                

// number of text strings in the game
// to display a text string at (A,E), call STEXT where the string # is in c.
#define NUM     69
#define ITEMS   28

char str[70][300] = {
        // items (24 items in the game)
        "HERB",
        "REMEDY",
        "ELIXER",

        "SWORD",
        "LNGSWD",
        "AXE",
        "SLICER",
        "XCALBR",

        "BOW",
        "LNGBOW",
        "CRSBOW",
        "SLVRBW",

        "STAFF",
        "WAND",

        "DAGGER",
        "SCMITR",
        "CUTLAS",

        "CLOTH",
        "LEATHR",
        "ROBE",
        "CHAIN",
        "PLATE",
        "VEST",
        "FAITH",

        // shop/inn msgs
        "WELCOME TO THE\nWEAPON SHOP. HOW\nMAY I HELP YOU?",
        "WELCOME TO THE\nINN. A ROOM?\nONLY 10G!",
        "YOU DON'T HAVE\nENOUGH GOLD!",
        "YOU CAN'T CARRY\nANY MORE ITEMS!",
        "THANK YOU.",

        // menu strings
        "SEARCH\nITEM\nSTATUS\nSAVE",
        "EQUIP\nDROP",
        "USE\nDROP",
        "NO\nYES",

        // town1
        "WELCOME TO JESPER.\nTHE SECOND CAVE\nIS ON THE BEACH\nTO THE EAST.",
        "CALCULATOR GAME?\nWHAT THE HECK?!",
        "JUSTIN:\n\n  \"I LOVE LISA!\"",
        "THE FIFTH CAVE IS\nNEARBY,BUT I\nWOULDN'T MESS\nWITH IT.",

        // town2
        "HEY! WELCOME TO\nTHE MOUNTAIN TOWN.",
        "THE 8TH CAVE\nRESIDES IN THIS\nROCKY MOUNTAIN\nAREA.",
        "THE WINDS OF\nTIME ABOUND. GOT\nANY FRAGMENTS?",
        "TOM: I ASK TO\nBE IN JOLTIMA,AND\nLOOK WHERE HE PUTS\nME!",

        // town3 (center town)
        "THE SHARDS ARE\nIN THE 8 CAVES.",
        "EACH CAVE GETS\nPROGRESSIVELY\nHARDER. GO SOUTH\nTO THE EASY CAVE.",
        "THE SECOND CAVE\nIS TO THE NORTH-\nEAST.",
        "THROUGH A FOREST\nYOU CANNOT SEE,\nBUT WALK.\nREMEMBER THIS.",

        // town4
        "CAMPING OUT IN\nGOOD FORESTRA.\nEH, LAD?",
        "JESUS IS LORD.",
        "LOTS OF GOOD\nCAVES NEARBY.\nHOPE YOU ARE\nEXPERIENCED.",
        "THE THIRD CAVE\nIS TO THE SOUTH-\nEAST. FOURTH IS\nMIDDLE EAST.",

        // town5
        "BEACHES ROCK!\nFROM HERE I CAN\nSCOPE OUT THE\nCALCULATOR BABES!",
        "JEFF: RETURN\nWHEN YOU HAVE ALL\nEIGHT SHARDS.",
        "THE ONLY WAY TO\nREACH THE ISLAND\nIS WITH A BOAT",
        "DON'T FORGET,\nYOUR CALCULATOR\nIS GOOD FOR\nGRAPHING,ALSO.",

        // attack menu
        "ATTACK\nITEM\nRUN",

        "CONTINUE\nNEW",
        "SADLY, THE WORLD\nWAS NEVER SAVED..\n",
        "LEV UP!",

        "UNABLE TO EQUIP!",
        "PLAYER ISN'T WITH\nUS...",
        "YOU HAVE NO ITEMS!",

        // opening
        "     WELCOME, MEN!\nYOU HAVE BEEN APPOINTED\nBY ME, LISA OF DAPHNAR,\n TO FREE OUR LAND FROM\n   TURMOIL. THE EVIL\nWIZARD KORIFCA HAS TAK-\n EN OVER THE MONSTERS\n TO FIGHT AS HIS ARMY.\nHE CAN BE STOPPED ONLY\nONE WAY -- THE SHARDS!",
        // ending
        " AT LAST, KORIFCA WAS\nDEFEATED. HIS EVILNESS\n WILL NEVER RETURN TO\n THE LAND OF DAPHNAR.\n  ALL THE KINGDOM RE-\nJOICES IN THE VICTORY.\n WHO KNOWS WHAT AWAITS\n OUR BAND OF CRUSADERS\nON THEIR NEXT JOURNEY?",

        "IS IT MORNING\nALREADY?",

        // boat msgs
        //"ARR! AHOY MATEY!"
        //"ARR! 'TIS A PIR-\nATE'S LIFE."
        //"ARR! OFF TO THE\nISLAND, LAD?"
        //"ARR! IS AFTER Q!"

        // special msgs
        "JEFF: WHOA! YOU\nHAVE ALL THE\nSHARDS! QUICKLY!\nTO THE SHIP!",

        // end boss msgs
        "KORIFCA: COME TO\nCHALLENGE ME?\nHEHEHE! YOU ARE\nNOTHING!!!",
        "KORIFCA: NO!!! IT\nCAN'T BE! THE\nSHARDS?! HOW???\nAHHRGGGGHHH!!!",

        "SHALL WE RETURN?",

        "CAN'T RUN!",
        "ESCAPED!",
};

/* this is the data for all townsfolk.  each column is documented in the
   original source (J.AS). each break indicates a new town.
*/
char towndata[485] = {
        6,                      // number of people in the town
        18, 23,  5, 0, 33,      // X,Y, character type, what he does, msg#
        25, 18,  4, 0, 34,
         8,  8,  5, 1,  0,
        29, 25,  4, 2,  0,
        25,  5,  4, 0, 35,
        11, 19,  4, 0, 36,
        
        6,
        12, 16,  5, 0, 37,
        24, 25,  4, 0, 38,
         7, 11,  5, 0, 39,
        14, 24,  4, 0, 40,
        28,  8,  5, 2,  0,
        27, 21,  4, 1,  1,

        6,
        13,  8,  5, 2,  0,
        26, 25,  4, 1,  2,
        14, 16,  4, 0, 41,
        22, 14,  5, 0, 42,
        24, 21,  5, 0, 43,
        17, 24,  4, 0, 44,

        6,
        24, 17,  5, 0, 45,
        29,  7,  4, 0, 46,
        28, 25,  4, 0, 47,
        11, 12,  5, 0, 48,
        21,  5,  5, 2,  0,
         9, 25,  4, 1,  3,

        6,
        10,  9,  5, 2,  0,
        28, 10,  4, 1,  4,
        21, 20,  4, 0, 49,
        15, 15,  4, 0, 50,
        20,  8,  5, 0, 51,
         8, 16,  5, 0, 52,
};

/*
        This is straight from J.AS.
*/
char ext_data[] = {
/*
; townxy          at    enter    exit   map#
; ------        ------  ------  ------- -
townxy  .db     64,12,  18,28,  64, 13, 0
        .db     19,11,   7,16,  19, 12, 1
        .db     33,28,   7,17,  33, 29, 2
        .db     64,48,  30,17,  65, 48, 3
        .db     30,47,  18, 5,  30, 46, 4

; these are caves (checked with same routine)
        .db     32,34,  18,28,  33, 34, 5
        .db     77, 4,  18,28,  76,  4, 6
        .db     74,59,  18,28,  74, 58, 7
        .db     77,26,  18,28,  77, 27, 8
        .db     50, 5,  18,28,  50,  6, 9
        .db      8,58,  18,28,   7, 58, 10
        .db     34,55,  18,28,  34, 56, 11
        .db     25,12,  18,28,  26, 12, 12
*/
                64,12,  18,28,  64, 13, 0,
                19,11,   7,16,  19, 12, 1,
                33,28,   7,17,  33, 29, 2,
                64,48,  30,17,  65, 48, 3,
                30,47,  18, 5,  30, 46, 4,
                
                32,34,  18,28,  33, 34, 5,
                77, 4,  18,28,  76,  4, 6,
                74,59,  18,28,  74, 58, 7,
                77,26,  18,28,  77, 27, 8,
                50, 5,  18,28,  50,  6, 9,
                 8,58,  18,28,   7, 58, 10,
                34,55,  18,28,  34, 56, 11,
                25,12,  18,28,  26, 12, 12,
                26,58,  18,28,  26, 57, 13,
/*
; searchdata - 5 bytes apiece: maptype,mapnum,x,y,item#
        ; remember that from caves, subtract from both coords:
        ; x -= 24 * xmap + 7, y -= 24 * ymap + 5
*/
        // overworld items
                0, 0,18,59, 2,
                0, 0,25,43, 1,
                0, 0, 6, 4, 2,
                0, 0,69,41, 1,
                0, 0,43,33, 2,

        // town items                
                1, 0, 8,26, 0,
                1, 1, 7,14,13,

        // cave 1
                2, 5,26,27, 0,
                2, 5,20,16, 4,
                2, 5,29, 8, 255,

        // cave 2
                2, 6,27,16, 1,
                2, 6,11,11, 255,

        // cave 3
                2, 7,13,20, 10,
                2, 7,27,10, 255,

        // cave 4
                2, 8,14, 8, 255,

        // cave 5
                2, 9,14,12, 19,
                2, 9,23,12, 255,

        // cave 6
                2,10,13,17, 255,
                2,10,28,11, 16,
                2,10,13,11, 22,

        // cave 7
                2,11, 8,16, 255,
                2,11,12,14, 21,
                2,11,24, 8, 2,

        // cave 8
                2,12,25,23, 2,
                2,12,10,10, 255,

        // cave 9
                2,13,20,10, 11,
                2,13,27,19, 7,
                2,13,29,21, 23,
/*
        ENEMY DATA!  [hp,str,def,agl] 10 enemies
*/
//      3, 2, 0, 1,     // rat
//      5, 3, 1, 3,     // bird
//     10, 5, 1, 5,     // blob
//     16, 8, 3, 6,     // zombie
//     29,12, 2, 2,     // jelly
//     47,15, 4,15,     // stingray
//     65,18, 5, 8,     // eyeball
//     75,23, 7,15,     // wolf
//    100,30,10,35,     // sentry
//    220,40,10,30,     // boss

        3, 2, 0, 1,     // rat
        6, 3, 1, 3,     // bird
       10, 7, 3, 5,     // blob
       16,10, 6,10,     // zombie
       29,17, 7,12,     // jelly
       47,15, 8,20,     // stingray
       65,18,10,18,     // eyeball
       75,23,12,27,     // wolf
      120,35,20,35,     // sentry
      220,45,20,30,     // boss
/*
        Battle formations [num,gold,exp,enemy1,2,3,4,5] -- 28 formations
*/
        2, 1, 1, 0, 0, 0, 0, 0, // 2 rats
        4, 2, 1, 0, 0, 0, 0, 0, // 4 rats
        2, 1, 2, 1, 1, 0, 0, 0, // 2 birds

        4, 2, 2, 0, 0, 1, 1, 0, // 2 rats, 2 birds
        5, 1, 2, 0, 0, 0, 0, 0, // 5 rats
        1, 2, 2, 2, 0, 0, 0, 0, // 1 blob

        3, 2, 3, 1, 1, 2, 0, 0, // 2 birds, 1 blob
        3, 3, 4, 2, 2, 2, 0, 0, // 3 blobs
        5, 4, 4, 2, 2, 1, 1, 0, // 2 blobs, 2 birds, 1 rat

        2, 5, 4, 3, 3, 0, 0, 0, // 2 zombies
        4, 5, 5, 2, 2, 3, 3, 0, // 2 blobs, 2 zombies
        5, 4, 5, 3, 1, 1, 2, 2, // 1 zombie, 2 birds, 2 blobs

        2, 4, 5, 5, 3, 0, 0, 0,
        4, 6, 5, 4, 4, 3, 3, 0,
        5, 5, 6, 3, 4, 3, 2, 2,

        2, 6, 6, 4, 6, 0, 0, 0,
        3, 7, 6, 5, 5, 5, 0, 0,
        5, 6, 7, 4, 5, 4, 3, 3,

        4, 7, 8, 5, 6, 5, 5, 0,
        2, 7, 6, 7, 5, 0, 0, 0,
        3, 7, 7, 6, 5, 6, 0, 0,

        3, 9, 7, 6, 7, 5, 0, 0,
        2, 5, 7, 7, 7, 0, 0, 0,
        2, 8, 8, 8, 7, 0, 0, 0,

        3, 9, 9, 6, 6, 7, 0, 0,
        5, 9,10, 7, 8, 7, 6, 6,
        2,10, 9, 8, 8, 0, 0, 0,

        5, 0, 0, 8, 9, 8, 8, 8, // Final battle
/*
; shopdata - 8 bytes apiece = the four items for sale their prices
shopdata
        .db     1, 10,  2, 10,  3, 15,  4, 35
        .db     0,  0,  0,  0,  0,  0,  0,  0
        .db     0,  0,  0,  0,  0,  0,  0,  0
        .db     0,  0,  0,  0,  0,  0,  0,  0
        .db     0,  0,  0,  0,  0,  0,  0,  0
*/
                0, 10,  1, 20,  9, 30, 21,180,
                2, 30,  6,180, 16,200, 22,245,
                0, 10,  4, 25, 18, 10, 20, 30,
                1, 20, 10, 90, 15,100, 19, 90,
                1, 20,  2, 30,  5, 90, 21,180,
/*
; ITEM DATA
; bytes:
;       1 = Compatability.  bits 1-4 = class type 1-4  [15 = used by all]
;       2 = Type of item.   0 = healing item, 1 = weapon, 2 = armor
;       3 = Power of item.  (amount healed, strength, or defense)
itemdata
        .db     15,0,10 ; 00: herb
        .db     15,0,50 ; 01: remedy
        .db     15,0,99 ; 02: elixer

        .db      1,1,2  ; 03: sword
        .db      1,1,4  ; 04: long sword
        .db      1,1,8  ; 05: axe
        .db      1,1,12 ; 06: slicer
        .db      1,1,18 ; 07: excalibur

        .db      2,1,0  ; 08: bow
        .db      2,1,0  ; 09: longbow
        .db      2,1,0  ; 10: crossbow
        .db      2,1,0  ; 11: silver bow

        .db      4,1,0  ; 12: staff
        .db      4,1,0  ; 13: wand

        .db      8,1,0  ; 14: dagger
        .db      8,1,0  ; 15: scimitar
        .db      8,1,0  ; 16: cutlass

        .db     15,2,0  ; 17: cloth
        .db     15,2,0  ; 18: leather
        .db      4,2,0  ; 19: robe
        .db      1,2,0  ; 20: chain
        .db      1,2,0  ; 21: plate
        .db     15,2,0  ; 22: vest
        .db      4,2,0  ; 23: faith
*/
                15,0,10,//; 00: herb
                15,0,50,//; 01: remedy
                15,0,99,//; 02: elixer

                 1,1, 2,//; 03: sword
                 1,1, 4,//; 04: long sword
                 1,1, 8,//; 05: axe
                 1,1,12,//; 06: slicer
                 1,1,18,//; 07: excalibur

                 2,1, 1,//; 08: bow
                 2,1, 3,//; 09: longbow
                 2,1, 7,//; 10: crossbow
                 2,1,12,//; 11: silver bow

                 4,1, 0,//; 12: staff
                 4,1, 0,//; 13: wand

                 8,1, 1,//; 14: dagger
                 8,1, 4,//; 15: scimitar
                 8,1, 8,//; 16: cutlass

                15,2, 0,//; 17: cloth
                15,2, 2,//; 18: leather
                 4,2, 3,//; 19: robe
                 1,2, 4,//; 20: chain
                 1,2, 8,//; 21: plate
                15,2,12,//; 22: vest
                15,2,20,//; 23: faith
/*

/* VIEW - lookup table to reduce the number of calculations necessary for
          the vision routine.
*/
; view - (right side)
view    .db      0, -1,  0, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0
        .db      0, -1,  1, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0
        .db      1, -1,  0, -1,  1, -1,  0, -1, 15,  0,  0,  0,  0
        .db      1, -1,  1, -1,  0, -1,  1, -1, 15,  0,  0,  0,  0
        .db      1, -1,  1, -1,  1, -1,  1, -1, 15,  0,  0,  0,  0

        .db      1, -1,  1, -1,  1,  0,  1, -1,  1, -1, 15,  0,  0
        .db      1, -1,  1,  0,  1, -1,  1, -1,  1,  0,  1, -1, 15
        .db      1, -1,  1,  0,  1, -1,  1,  0,  1, -1,  1,  0, 15
        .db      1,  0,  1, -1,  1,  0,  1,  0,  1, -1,  1,  0, 15
        .db      1,  0,  1,  0,  1, -1,  1,  0,  1,  0,  1,  0, 15

        .db      1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0, 15
        .db      1,  0,  1,  0,  1,  1,  1,  0,  1,  0,  1,  0, 15
        .db      1,  0,  1,  1,  1,  0,  1,  0,  1,  1,  1,  0, 15
        .db      1,  1,  1,  0,  1,  1,  1,  0,  1,  1,  1,  0, 15
        .db      1,  1,  1,  0,  1,  1,  1,  1,  1,  0,  1,  1, 15

        .db      1,  1,  1,  1,  1,  0,  1,  1,  1,  1, 15,  0,  0
        .db      1,  1,  1,  1,  1,  1,  1,  1, 15,  0,  0,  0,  0
        .db      1,  1,  1,  1,  0,  1,  1,  1, 15,  0,  0,  0,  0
        .db      1,  1,  0,  1,  1,  1,  0,  1, 15,  0,  0,  0,  0
        .db      0,  1,  1,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0

; view - (left side) [sign switch]       
        .db      0,  1,  0,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0
        .db      0,  1, -1,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0
        .db     -1,  1,  0,  1, -1,  1,  0,  1, 15,  0,  0,  0,  0
        .db     -1,  1, -1,  1,  0,  1, -1,  1, 15,  0,  0,  0,  0
        .db     -1,  1, -1,  1, -1,  1, -1,  1, 15,  0,  0,  0,  0

        .db     -1,  1, -1,  1, -1,  0, -1,  1, -1,  1, 15,  0,  0
        .db     -1,  1, -1,  0, -1,  1, -1,  1, -1,  0, -1,  1, 15
        .db     -1,  1, -1,  0, -1,  1, -1,  0, -1,  1, -1,  0, 15
        .db     -1,  0, -1,  1, -1,  0, -1,  0, -1,  1, -1,  0, 15
        .db     -1,  0, -1,  0, -1,  1, -1,  0, -1,  0, -1,  0, 15

        .db     -1,  0, -1,  0, -1,  0, -1,  0, -1,  0, -1,  0, 15
        .db     -1,  0, -1,  0, -1, -1, -1,  0, -1,  0, -1,  0, 15
        .db     -1,  0, -1, -1, -1,  0, -1,  0, -1, -1, -1,  0, 15
        .db     -1, -1, -1,  0, -1, -1, -1,  0, -1, -1, -1,  0, 15
        .db     -1, -1, -1,  0, -1, -1, -1, -1, -1,  0, -1, -1, 15

        .db     -1, -1, -1, -1, -1,  0, -1, -1, -1, -1, 15,  0,  0
        .db     -1, -1, -1, -1, -1, -1, -1, -1, 15,  0,  0,  0,  0
        .db     -1, -1, -1, -1,  0, -1, -1, -1, 15,  0,  0,  0,  0
        .db     -1, -1,  0, -1, -1, -1,  0, -1, 15,  0,  0,  0,  0
        .db      0, -1, -1, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0
*/
                 0, -1,  0, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0,
                 0, -1,  1, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0,
                 1, -1,  0, -1,  1, -1,  0, -1, 15,  0,  0,  0,  0,
                 1, -1,  1, -1,  0, -1,  1, -1, 15,  0,  0,  0,  0,
                 1, -1,  1, -1,  1, -1,  1, -1, 15,  0,  0,  0,  0,

                 1, -1,  1, -1,  1,  0,  1, -1,  1, -1, 15,  0,  0,
                 1, -1,  1,  0,  1, -1,  1, -1,  1,  0,  1, -1, 15,
                 1, -1,  1,  0,  1, -1,  1,  0,  1, -1,  1,  0, 15,
                 1,  0,  1, -1,  1,  0,  1,  0,  1, -1,  1,  0, 15,
                 1,  0,  1,  0,  1, -1,  1,  0,  1,  0,  1,  0, 15,

                 1,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0, 15,
                 1,  0,  1,  0,  1,  1,  1,  0,  1,  0,  1,  0, 15,
                 1,  0,  1,  1,  1,  0,  1,  0,  1,  1,  1,  0, 15,
                 1,  1,  1,  0,  1,  1,  1,  0,  1,  1,  1,  0, 15,
                 1,  1,  1,  0,  1,  1,  1,  1,  1,  0,  1,  1, 15,

                 1,  1,  1,  1,  1,  0,  1,  1,  1,  1, 15,  0,  0,
                 1,  1,  1,  1,  1,  1,  1,  1, 15,  0,  0,  0,  0,
                 1,  1,  1,  1,  0,  1,  1,  1, 15,  0,  0,  0,  0,
                 1,  1,  0,  1,  1,  1,  0,  1, 15,  0,  0,  0,  0,
                 0,  1,  1,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0,


                 0,  1,  0,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0,
                 0,  1, -1,  1,  0,  1,  0,  1, 15,  0,  0,  0,  0,
                -1,  1,  0,  1, -1,  1,  0,  1, 15,  0,  0,  0,  0,
                -1,  1, -1,  1,  0,  1, -1,  1, 15,  0,  0,  0,  0,
                -1,  1, -1,  1, -1,  1, -1,  1, 15,  0,  0,  0,  0,

                -1,  1, -1,  1, -1,  0, -1,  1, -1,  1, 15,  0,  0,
                -1,  1, -1,  0, -1,  1, -1,  1, -1,  0, -1,  1, 15,
                -1,  1, -1,  0, -1,  1, -1,  0, -1,  1, -1,  0, 15,
                -1,  0, -1,  1, -1,  0, -1,  0, -1,  1, -1,  0, 15,
                -1,  0, -1,  0, -1,  1, -1,  0, -1,  0, -1,  0, 15,

                -1,  0, -1,  0, -1,  0, -1,  0, -1,  0, -1,  0, 15,
                -1,  0, -1,  0, -1, -1, -1,  0, -1,  0, -1,  0, 15,
                -1,  0, -1, -1, -1,  0, -1,  0, -1, -1, -1,  0, 15,
                -1, -1, -1,  0, -1, -1, -1,  0, -1, -1, -1,  0, 15,
                -1, -1, -1,  0, -1, -1, -1, -1, -1,  0, -1, -1, 15,

                -1, -1, -1, -1, -1,  0, -1, -1, -1, -1, 15,  0,  0,
                -1, -1, -1, -1, -1, -1, -1, -1, 15,  0,  0,  0,  0,
                -1, -1, -1, -1,  0, -1, -1, -1, 15,  0,  0,  0,  0,
                -1, -1,  0, -1, -1, -1,  0, -1, 15,  0,  0,  0,  0,
                 0, -1, -1, -1,  0, -1,  0, -1, 15,  0,  0,  0,  0,
};

void
main()
{
        FILE *f;
        int n;
        int offset;

        f = fopen("zjtext.bin", "wb");
        /* first record the table */
        n = NUM;
        fwrite(&n, 1, 1, f);
        offset = 0;
        for(n = 0; n < NUM; ++n) {
                fwrite(&offset, 2, 1, f);
                offset += strlen(str[n]) + 1;
        }
        
        /* now write the strings in */
        for(n = 0; n < NUM; ++n) {
                fwrite(str[n], strlen(str[n]) + 1, 1, f);
        }
        fclose(f);
        printf("Wrote %d strings.\n", NUM);

        /* oh, ya, and do the towndata also */
        f = fopen("towndata.bin", "wb");
        fwrite(towndata, 155, 1, f);
        fclose(f);
        
        /* oh, and the extra crap */
        f = fopen("ext_data.bin", "wb");
        fwrite(ext_data, 210 + 40+224 + 5*ITEMS + 520, 1, f);
        fclose(f);

        printf("If anything was altered, then CHANGE THE PROGRAM TO MATCH SIZE!!\n");
}
